VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cCreateConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Connectings     As New Collection
Private dlgWorkings     As New Collection
Dim KeyEx               As New CKeyExchange

Public Event CancelConnecting(RemoteIP As String, ChatNick As String, ChatId As String, ConnectionType As String, ErrorMessage As String)
Public Event GotConnection(RemoteIP As String, ChatNick As String, Key As String, ChatId As String, ConnectionType As String)
Public Event GotStateMessage(NickName As String, RemoteIP As String, iOnlineState As ClientOnlineState, StateMessage As String)

Public Function ConnectClient(ChatNick As String, ByVal RemoteIP As String, Optional ByVal LAN_IP As String = "", Optional ChatId As String = "", Optional HideWorkingDialog As Boolean = False, Optional ConnectionType As String = "CHAT", Optional ShowErrors As Boolean = True) As Long
    Dim curConnecting       As New clsConnecting, _
        tmpConnecting       As clsConnecting, _
        dlgWorking          As New dlgConnectingState, _
        lngTimeOut          As Long, _
        SearchChatWindow    As dlgChat, _
        ChatWindow          As dlgChat
    
    'search exist chat'
    Set ChatWindow = Nothing
    If ChatId = "" And ConnectionType = "CHAT" Then
       For Each SearchChatWindow In ChatWindows
          If LCase$(SearchChatWindow.LastChatNick) = LCase$(ChatNick) Then
             If SearchChatWindow.Connected Then
                 Exit Function
             Else
                 Set ChatWindow = SearchChatWindow
                 Exit For
             End If
          End If
       Next SearchChatWindow
    End If
    
    'check LAN'
    If RemoteIP = modClient.LocalUser.cpRemoteIP Then
        If LAN_IP <> "" Then
            RemoteIP = LAN_IP
        Else
            RemoteIP = dlgMain.ClientManagement.GetClientLAN_IP(ChatNick)
        End If
        If RemoteIP = "" Then Exit Function
    End If
   
    'create new connecting class'
    On Error Resume Next
    Set tmpConnecting = Connectings.Item(LCase$(ChatNick))
    On Error GoTo 0
    If Not tmpConnecting Is Nothing Then _
        Exit Function
    
    Call Connectings.Add(curConnecting, LCase$(ChatNick))
    curConnecting.IsConnected = False
    curConnecting.DstName = ChatNick
    curConnecting.DstRemoteIP = RemoteIP
    curConnecting.DstLAN_IP = LAN_IP
    curConnecting.ConnectingState = "START_CONNECTING"
    curConnecting.ConnectionType = ConnectionType
    curConnecting.ShowErrors = ShowErrors
    If ConnectionType = "CHAT" Then
        'chat connection'
        If ChatId = "" Then
            ChatId = CreateChatId(16)
            curConnecting.IsPrimaryHost = True
            If Not ChatWindow Is Nothing Then
                Call ChatWindows.Remove(ChatWindow.ChatId)
                Call ChatWindows.Add(ChatWindow, ChatId)
                ChatWindow.ChatId = ChatId
            End If
        Else
            If ExistChatWindow(ChatId) Then
                Set ChatWindow = ChatWindows.Item(ChatId)
            Else
                Set ChatWindow = New dlgChat
                Call ChatWindow.Hide
                Call ChatWindows.Add(ChatWindow, ChatId)
            End If
            curConnecting.IsPrimaryHost = False
        End If
    Else
        'no chat connection'
        ChatId = CreateChatId(16)
    End If
    curConnecting.ChatId = ChatId
   
    On Local Error Resume Next
    Call dlgWorkings.Remove(LCase$(ChatNick))
    On Local Error GoTo 0
    
    Call dlgWorkings.Add(dlgWorking, LCase$(ChatNick))
    If Not HideWorkingDialog Then
        dlgWorking.Show 0, dlgMain
        dlgWorking.AddDebugMsg = "Start Connecting"
    Else
        dlgWorking.Hide
    End If
    dlgWorking.Caption = "Verbindungssuche"
    dlgWorking.Message = "Suche Verbindungsmglichkeit zu" & vbCrLf & "''" & ChatNick & "''..."
    dlgWorking.RemoteIP = RemoteIP
    dlgWorking.ChatNick = ChatNick
'    dlgWorking.tmrConnectingTimer.Enabled = False
    dlgWorking.tmrConnectingTimer.Enabled = True
    Call curConnecting.StartTimeOut(30)
    
    Debug.Print
    Debug.Print "Trying to connect to " & ChatNick & " [" & RemoteIP & "]"
    dlgWorking.AddDebugMsg = "Trying to Connect"
    
    If Not MyConnection.clsWinSock_SendDatas(ChatNick, RemoteIP, ChatNick, CONNECTION_STILL_MESSAGE) Then
        strNewConnectionIP = vbNullString
        strNewConnectionUser = vbNullString
        strRoutingConnectionIP = vbNullString
        strRoutingConnectionUser = vbNullString

        dlgWorking.tmrConnectingTimer.Enabled = False
        dlgWorking.AddDebugMsg = "Faild to Connect"
        dlgWorking.AddDebugMsg = "Send Broadcast"
        
        'hier muss jetzt eingehackt werden
        dlgMain.ClientManagement.SendBroadcast FORWARD_BROADCAST_TO, RemoteIP, ChatNick
        For lngTimeOut = 0 To 50
            Sleep 100
            DoEvents
            If strNewConnectionIP = RemoteIP And _
                strNewConnectionUser = ChatNick Then Exit For
        Next
        If strNewConnectionIP = RemoteIP And strNewConnectionUser = ChatNick Then
            strNewConnectionIP = vbNullString
            strNewConnectionUser = vbNullString
            dlgWorking.AddDebugMsg = "Reconnect successfully"
            Call MyConnection.clsWinSock_SendDatas(ChatNick, RemoteIP, ChatNick, CONNECTION_STILL_MESSAGE)
'            Call Connection.clsWinSock_SendDatas("", NewChat.RemoteIP, NewChat.ChatNick, CONNECTION_STILL_ALIVE)
        ElseIf (LenB(strRoutingConnectionIP)) > 0 And (LenB(strRoutingConnectionUser)) > 0 Then
            'Connection muss geroutet werden
            'sehr wahrscheinlich kann ich nicht auf eingehende Requests reagieren
            dlgWorking.AddDebugMsg = "Routingclient found"
            Call MyConnection.clsWinSock_SendDatas(vbNullString, strRoutingConnectionIP, strRoutingConnectionUser, CONNECTION_STILL_MESSAGE, RemoteIP, ChatNick, , , ROUTING_FORWARD_TO)
        Else
            'connection error'
            Debug.Print "Got no connection to " & ChatNick & " [" & RemoteIP & "]"

            If curConnecting.ShowErrors Then
               RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "Es konnte keine Verbindung zu ''" & ChatNick & "'' hergestellt werden.")
            Else
               RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "")
            End If
            
            Call modClient.ConnectionCancel(ChatNick)
            Call QuitConnecting(ChatNick, True)
            Unload dlgWorking
            Call EraseWorkingDialog(ChatNick)
            
            Exit Function
        End If
        
        Debug.Print "Got broadcast connection to " & ChatNick & " [" & RemoteIP & "]"
        Call dlgMain.ClientManagement.ResetUnknownState(ChatNick)
                
    Else
        Debug.Print "Got direct connection to " & ChatNick & " [" & RemoteIP & "]"
        Call dlgMain.ClientManagement.ResetUnknownState(ChatNick)
        dlgWorking.AddDebugMsg = "Directconnection establish"
    End If
        
    'show chat window'
    If ConnectionType = "CHAT" Then
        If Not ExistChatWindow(ChatId) Then
            Set ChatWindow = New dlgChat
            Call ChatWindow.Hide
            ChatWindow.ChatId = ChatId
            Call ChatWindow.AddConferenceClient(ChatNick, RemoteIP)
            ChatWindow.Connected = False
            Call ChatWindows.Add(ChatWindow, ChatId)
        Else
            Call ChatWindow.AddConferenceClient(ChatNick, RemoteIP)
            ChatWindow.Connected = False
        End If
    End If

End Function

Public Sub ReceiveStateMessage(NickName As String, RemoteIP As String, iOnlineState As ClientOnlineState, StateMessage As String)
   Call dlgMain.ClientManagement.SetClient(NickName, , iOnlineState, , True)
   RaiseEvent GotStateMessage(NickName, RemoteIP, iOnlineState, StateMessage)

End Sub

Public Sub EstablishIMBasics(m_RemoteIP As String, m_ChatNick As String)
    
    Dim dlgW    As dlgConnectingState
    Dim KeySet  As KeyValueType
    
    Set dlgW = dlgWorkings.Item(LCase$(m_ChatNick))
    dlgW.Message = CStr("Schlssel zum sicheren Datenaustausch zu" & vbCrLf & "''" & m_ChatNick & "'' wird generiert...")
    dlgW.Caption = "Schlsselaustausch"
    
    dlgW.AddDebugMsg = "Creating Diffie Hellmann values for KeyExchange ..." & m_ChatNick & " [" & m_RemoteIP & "]"
    
    KeySet.p = CLng(KeyEx.Create_p)
    KeySet.G = CLng(KeyEx.Create_g)
    KeySet.a = CLng(KeyEx.Create_g)
    KeySet.Alpha = CLng(KeyEx.Create_alpha(CSng(KeySet.G), CSng(KeySet.a), CSng(KeySet.p)))
    
    Call MyConnection.clsWinSock_SendDatas( _
         Encoder.GetCommandLine( _
                "CRYPT_SEND_BASICS", _
                modClient.LocalUser.cpUsername, _
                CStr(KeySet.p), _
                CStr(KeySet.G), _
                CStr(KeySet.Alpha) _
           ), _
         m_RemoteIP, _
         m_ChatNick _
      )
    
    dlgW.KeyValues = KeySet
    dlgW.AddDebugMsg = "Done, KeyExchange"
End Sub

Public Sub EstablishSecureIM(m_RemoteIP As String, ByVal beta As Long, m_ChatNick As String)
    
    Dim dlgW    As dlgConnectingState
    Dim src()   As Byte
    Dim tgt()   As Byte
    Dim KeySet  As KeyValueType
    Dim Key     As String
    Dim CodeKey As String
    
    Set dlgW = dlgWorkings(LCase$(m_ChatNick))
        
    KeySet = dlgW.KeyValues
    KeySet.beta = beta
    KeySet.k = CLng(KeyEx.Create_k(CSng(beta), CSng(KeySet.a), CSng(KeySet.p)))
    
    Debug.Print
    Debug.Print "*********** KEY-SETTING TO " & m_ChatNick & " **********"
    Debug.Print "G    : " & KeySet.G
    Debug.Print "P    : " & KeySet.p
    Debug.Print "a    : " & KeySet.a
    Debug.Print "Alpha: " & KeySet.Alpha
    Debug.Print "k    : " & KeySet.k
    Debug.Print "*********** END KEY-SETTING **********"
    Debug.Print
    
    dlgW.AddDebugMsg = "Creating Key for further coding ..."
    Key = KeyEx.CreateKey(64)
    Debug.Print "Done"
    Debug.Print "KEY: " & Key
    Keys.AddKey m_RemoteIP, m_ChatNick, Key

    Debug.Print "Crypt & send key ..."
    Call String_to_byteArray(Key, src)
    Call CryptoInstance.Crypt(src, tgt, CStr(KeySet.k), False)
    CodeKey = byteArray_to_string(tgt)
    
    Call MyConnection.clsWinSock_SendDatas( _
         Encoder.GetCommandLine("CRYPT_SEND_PW", GetChatId(m_ChatNick), modClient.LocalUser.cpUsername, CodeKey), _
         m_RemoteIP, _
         m_ChatNick _
      )
    Debug.Print "Done"
    dlgW.AddDebugMsg = "Connection ready"
    Debug.Print
    Call EraseWorkingDialog(m_ChatNick)
    RaiseEvent GotConnection(m_RemoteIP, m_ChatNick, Key, GetChatId(m_ChatNick), "CHAT")
        
End Sub


Public Sub GotSecureBasics(m_RemoteIP As String, beta As Long, G As Long, p As Long, m_ChatNick As String)

    'check black list'
    If (dlgMain.ClientManagement.GetClientRelationship(m_ChatNick) = crUnwanted) Or _
        ((modSettings.GetSetting("ClientRelationship", "BlockUnknown") = "1") And _
        dlgMain.ClientManagement.GetClientRelationship(m_ChatNick) = crNone) _
    Then
        'unwanted client'
         Debug.Print m_ChatNick & " [" & m_RemoteIP & "] is trying to connect"
         Debug.Print m_ChatNick & " is unwanted, cancel creating connection ..."
         Call MyConnection.clsWinSock_SendDatas( _
           Encoder.GetCommandLine("IGNORE", modClient.LocalUser.cpUsername), _
           m_RemoteIP, _
           m_ChatNick _
         )
   
        Debug.Print "Ignored"
        Debug.Print
        
        Exit Sub
   
    Else
        'check own online state'
        Select Case modClient.LocalUser.cpOnlineState
            Case cosOnline, cosWantChat, cosUnknown
                'accept connection'
                'NOP'
        
            Case cosOffline
                'error'
                Exit Sub
        
            Case Else
                'the current state do not allow a chat connection'
                'send state message'
                Call MyConnection.clsWinSock_SendDatas( _
                    Encoder.GetCommandLine("STATEMSG", _
                        modClient.LocalStateMessage, _
                        modClient.LocalUser.cpOnlineState, _
                        modClient.LocalUser.cpRemoteIP, _
                        modClient.LocalUser.cpUsername _
                    ), _
                    m_RemoteIP, _
                    m_ChatNick _
                )
                        
        End Select
    
    End If
    
    Dim dlgWorking      As New dlgConnectingState
    Dim KeySet          As KeyValueType
    
    On Local Error Resume Next
    Call dlgWorkings.Remove(m_ChatNick)
    On Local Error GoTo 0
    Call dlgWorkings.Add(dlgWorking, "in" & LCase$(m_ChatNick))
        
    Debug.Print
    Debug.Print m_ChatNick & " [" & m_RemoteIP & "] is trying to connect"
    Debug.Print "Got KeyExchange basic values"
    Debug.Print "Creating response ..."
    
'    dlgWorking.Show 0, dlgMain
    dlgWorking.Hide
    dlgWorking.Message = "Schlssel zum sicheren Datenaustausch zu" & vbCrLf & "''" & m_ChatNick & "'' wird generiert..."
    dlgWorking.Caption = "Schlsselaustausch"
    dlgWorking.RemoteIP = m_RemoteIP
    dlgWorking.ChatNick = m_ChatNick
    
    KeySet.p = p
    KeySet.G = G
    

    KeySet.beta = beta
    KeySet.a = KeyEx.Create_g
    KeySet.Alpha = KeyEx.Create_alpha(CSng(KeySet.G), CSng(KeySet.a), CSng(KeySet.p))
    KeySet.k = KeyEx.Create_k(CSng(KeySet.beta), CSng(KeySet.a), CSng(KeySet.p))
    
    dlgWorking.KeyValues = KeySet
    
    Call MyConnection.clsWinSock_SendDatas( _
         Encoder.GetCommandLine("CRYPT_SEND_BETA", modClient.LocalUser.cpUsername, KeySet.Alpha), _
         m_RemoteIP, _
         m_ChatNick _
      )
    Debug.Print "Done"
    Debug.Print "*********** KEY-SETTING TO " & m_ChatNick & " **********"
    Debug.Print "G    : " & KeySet.G
    Debug.Print "P    : " & KeySet.p
    Debug.Print "a    : " & KeySet.a
    Debug.Print "Alpha: " & KeySet.Alpha
    Debug.Print "k    : " & KeySet.k
    Debug.Print "*********** END KEY-SETTING **********"
End Sub

Public Sub GotKey(m_RemoteIP As String, Key As String, m_ChatNick As String, ChatId As String)
    Dim dlgW    As dlgConnectingState
    Dim src()   As Byte
    Dim tgt()   As Byte
    Dim KeySet  As KeyValueType
    
    Debug.Print "Got key for further coding. Decoding key ..."
    
    Set dlgW = dlgWorkings("in" & LCase$(m_ChatNick))
    KeySet = dlgW.KeyValues
    
    Call String_to_byteArray(Key, src())
    Call CryptoInstance.Crypt(src(), tgt(), CStr(KeySet.k), True)
    Key = byteArray_to_string(tgt())
    
    Keys.AddKey m_RemoteIP, m_ChatNick, Key
    Call EraseWorkingDialog("in" & m_ChatNick)
    
    Debug.Print "Done"
    Debug.Print "KEY: " & Key
    Debug.Print "Connection ready"
    Debug.Print
    
    RaiseEvent GotConnection(m_RemoteIP, m_ChatNick, Key, ChatId, "CHAT")
End Sub

Public Sub Ignored(m_RemoteIP As String, m_ChatNick As String)
    
    Dim dlgW    As dlgConnectingState
    
    Set dlgW = dlgWorkings(LCase$(m_ChatNick))
    dlgW.Message = "Autorisierung erforderlich."
'    dlgW.Caption = "Autorisierung"
    
    Dim SendRequest     As VbMsgBoxResult
    SendRequest = MsgBox("Sie sind nicht autorisiert eine Verbindung zu ''" & m_ChatNick & "'' herzustellen." & vbCrLf & "Mchten Sie eine Autorisierung anfordern?", vbYesNo + vbQuestion, "Autorisierung")
    
    If SendRequest = vbYes Then
        Call MyConnection.clsWinSock_SendDatas( _
             Encoder.GetCommandLine("AUTHORIZATION_REQUEST", modClient.LocalUser.cpUsername), _
             m_RemoteIP, _
             m_ChatNick _
          )
        
        dlgW.Message = "Warte auf Autorisierung..."
    Else
        Call EraseWorkingDialog(m_ChatNick)
        Call QuitConnecting(m_ChatNick)
    End If
End Sub

Public Sub AuthorizationRequest(m_RemoteIP As String, m_ChatNick As String)
    Dim Authorize   As VbMsgBoxResult
    
    If Not CBool(modSettings.GetSetting("ClientRelationship", "AllowAuth")) Then
        Call MyConnection.clsWinSock_SendDatas( _
             Encoder.GetCommandLine("AUTHORIZATION_RESPONSE", modClient.LocalUser.cpUsername, 0), _
             m_RemoteIP, _
             m_ChatNick _
          )
          Exit Sub
    End If
    
    Authorize = MsgBox("''" & m_ChatNick & "'' will mit Ihnen Verbindung aufnehmen." & vbCrLf & "Mchten Sie ''" & m_ChatNick & "'' autorisieren?", vbYesNo + vbQuestion, "Autorisierung")
    
    If Authorize = vbYes Then
        Call dlgMain.ClientManagement.SetClientRelationship(m_ChatNick, crNone)
        Call MyConnection.clsWinSock_SendDatas( _
             Encoder.GetCommandLine("AUTHORIZATION_RESPONSE", modClient.LocalUser.cpUsername, 1), _
             m_RemoteIP, _
             m_ChatNick _
          )
    Else
        Call MyConnection.clsWinSock_SendDatas( _
             Encoder.GetCommandLine("AUTHORIZATION_RESPONSE", modClient.LocalUser.cpUsername, 0), _
             m_RemoteIP, _
             m_ChatNick _
          )
    End If
End Sub

Public Sub GotAuthorizationResponse(m_RemoteIP As String, Accepted As Boolean, m_ChatNick As String)
    Call EraseWorkingDialog(m_ChatNick)
    If Accepted Then
'        Call MsgBox(m_ChatNick & " hat Sie akzeptiert!", vbOKOnly + vbInformation, "Glckwunsch!")
        Call ConnectClient(m_ChatNick, m_RemoteIP)
    Else
        Call MsgBox("Sie wurden nicht von ''" & m_ChatNick & "'' autorisiert.", vbOKOnly + vbExclamation, "Autorisierung")
    End If
End Sub

Public Function EraseWorkingDialog(m_ChatNick As String) As Boolean
    On Local Error Resume Next
    Unload dlgWorkings.Item(LCase$(m_ChatNick))
    Call dlgWorkings.Remove(LCase$(m_ChatNick))
    EraseWorkingDialog = True
End Function

'----------------------------------------------------

Public Sub RequestAccept(strSourceUser As String, strSourceIP As String)
   On Local Error GoTo ErrorHandler
   Dim curConnecting As New clsConnecting
   Dim dlgWorking As New dlgConnectingState
   
   Set curConnecting = Connectings(LCase$(strSourceUser))
   Set dlgWorking = dlgWorkings(LCase$(strSourceUser))
   
   Select Case curConnecting.ConnectingState
      Case "CREATE_ROUTE_TO_LAN"
         'create chat'
         curConnecting.IsConnected = True
         curConnecting.ConnectingState = "CONNECTED"
         dlgWorking.tmrConnectingTimer.Enabled = False
         dlgWorking.AddDebugMsg = "cCreateConnection::RequestAccept:Select Case:1"
         If curConnecting.ConnectionType = "CHAT" Then
            Call CreateChat(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.IsPrimaryHost)
         ElseIf curConnecting.ConnectionType = "STATEMSG_REQUEST" Then
            RaiseEvent GotConnection(curConnecting.DstRemoteIP, curConnecting.DstName, "", curConnecting.ChatId, curConnecting.ConnectionType)
            Call QuitConnecting(curConnecting.DstName)
         End If
         
      Case Else
         'create chat'
         dlgWorking.AddDebugMsg = "cCreateConnection::RequestAccept:Select Case:2"
         curConnecting.IsConnected = True
         curConnecting.ConnectingState = "CONNECTED"
         dlgWorking.tmrConnectingTimer.Enabled = False
         If curConnecting.ConnectionType = "CHAT" Then
            Call CreateChat(strSourceIP, strSourceUser, curConnecting.ChatId, curConnecting.IsPrimaryHost)
         Else
            RaiseEvent GotConnection(curConnecting.DstRemoteIP, curConnecting.DstName, "", curConnecting.ChatId, curConnecting.ConnectionType)
            Call QuitConnecting(curConnecting.DstName)
         End If
                  
   End Select
   
   Exit Sub
   
ErrorHandler:
   'NOP'
   
End Sub

Public Sub RequestRefused(strUserToConnect As String, strSourceUser As String, strSourceIP As String)
   Dim DstLAN_IP        As String, _
       DstRemoteIP      As String, _
       dlgWorking       As New dlgConnectingState, _
       curConnecting    As New clsConnecting
             
'   If UCase(strSourceUser) = UCase(LocalUser.cpUsername) Then
'      If curConnecting.ShowErrors Then
'         RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "Es konnte keine Verbindung zu ''" & strUserToConnect & "'' hergestellt werden.")
'      Else
'         RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "")
'      End If
'      Call modClient.ConnectionCancel(strUserToConnect)
'      Call QuitConnecting(strUserToConnect, True)
'   End If
             
   'get LAN IP of destination client'
   DstRemoteIP = dlgMain.ClientManagement.GetClientRemoteIP(strUserToConnect)
   DstLAN_IP = dlgMain.ClientManagement.GetClientLAN_IP(strUserToConnect)
   If DstLAN_IP = "" Or DstRemoteIP = "" Then
      Call modClient.ConnectionCancel(strUserToConnect)
      Call QuitConnecting(strUserToConnect)
      If curConnecting.ShowErrors Then MsgBox "Es konnte keine Verbindung zu ''" & strUserToConnect & "'' hergestellt werden.", vbOKOnly + vbExclamation, "Verbindungsfehler - Wertefehler"
      Exit Sub
   End If
      
   'get connecting data'
   Set curConnecting = Connectings(LCase$(strUserToConnect))
   
   If curConnecting.ConnectingState = "CREATE_ROUTE_TO_LAN" Then
      'connection accepted'
      curConnecting.IsConnected = True
      curConnecting.ConnectingState = "CONNECTED"
      dlgWorking.tmrConnectingTimer.Enabled = False
      If curConnecting.ConnectionType = "CHAT" Then
         Call CreateChat(curConnecting.DstLAN_IP, curConnecting.DstName, curConnecting.ChatId, curConnecting.IsPrimaryHost)
      Else
         RaiseEvent GotConnection(curConnecting.DstRemoteIP, curConnecting.DstName, "", curConnecting.ChatId, curConnecting.ConnectionType)
         Call QuitConnecting(curConnecting.DstName)
      End If
      Exit Sub
      
   End If

   curConnecting.IsConnected = False
   curConnecting.RouterName = strSourceUser
   curConnecting.RouterRemoteIP = strSourceIP
   
   'show working dialog'
   Set dlgWorking = Nothing
   If dlgWorkings.Count > 0 Then Set dlgWorking = dlgWorkings(LCase$(strUserToConnect))
   If dlgWorking Is Nothing Then
      Set dlgWorking = New dlgConnectingState
      On Local Error Resume Next
      Call dlgWorkings.Remove(LCase$(strUserToConnect))
      On Local Error GoTo 0
      
      Call dlgWorkings.Add(dlgWorking, LCase$(strUserToConnect))
      dlgWorking.Show 0, dlgMain
   End If
   
   'set working dialog'
   dlgWorking.Caption = "Verbindungssuche"
   dlgWorking.Message = "Suche Verbindungsmglichkeit zu" & vbCrLf & "''" & strUserToConnect & "''..."
   dlgWorking.RemoteIP = DstRemoteIP
   dlgWorking.ChatNick = strUserToConnect
   dlgWorking.AddDebugMsg = "RequestRefused"
   dlgWorking.AddDebugMsg = "Searching to LAN"
   
   
   If Not modConnection.FirewallOrNATRouter Then
      'the user should connect me'
      dlgWorking.AddDebugMsg = "Send Reconnect"
      If Not MyConnection.clsWinSock_SendDatas("", strSourceIP, strSourceUser, FORWARD_BROADCAST_TO_NEW, DstLAN_IP, strUserToConnect) Then
         Call modClient.ConnectionCancel(strUserToConnect)
         If curConnecting.ShowErrors Then MsgBox "Es konnte keine Verbindung zu ''" & strUserToConnect & "'' hergestellt werden.", vbOKOnly + vbExclamation, "Verbindungsfehler"
      End If
   
      'wait for connection'
      Call curConnecting.StartTimeOut(3)
      curConnecting.ConnectingState = "FORWARD_BROADCAST_TO_NEW"
      dlgWorking.tmrConnectingTimer.Enabled = True
   Else
      'we need a routing client'
      dlgWorking.AddDebugMsg = "Create LAN Route"
      If Not MyConnection.clsWinSock_SendDatas("", strSourceIP, strSourceUser, , DstLAN_IP, strUserToConnect, , , CREATE_ROUTE_TO_LAN) Then
         If curConnecting.ShowErrors Then
            RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "Es konnte keine Verbindung zu ''" & strUserToConnect & "'' hergestellt werden.")
         Else
            RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "")
         End If
         Call modClient.ConnectionCancel(strUserToConnect)
         Call QuitConnecting(strUserToConnect, True)
      End If
      
   End If

End Sub

Public Sub ConnectingTimer(ChatNick As String)
   On Local Error GoTo ErrorHandler
   Dim curConnecting As New clsConnecting
   Dim dlgWorking As New dlgConnectingState
   
   Set curConnecting = Connectings(LCase$(ChatNick))
   Set dlgWorking = dlgWorkings(LCase$(ChatNick))

   If curConnecting.IsTimeOut() Then
      'time is gone'
      dlgWorking.tmrConnectingTimer.Enabled = False
   
      Select Case curConnecting.ConnectingState
      
         Case "FORWARD_BROADCAST_TO_NEW"
            'we need a routing client'
            curConnecting.ConnectingState = ""
            If Not curConnecting.IsConnected Then
               If Not MyConnection.clsWinSock_SendDatas(curConnecting.DstName, curConnecting.RouterRemoteIP, curConnecting.RouterName, CONNECTION_STILL_MESSAGE, curConnecting.DstLAN_IP, curConnecting.DstName, , , CREATE_ROUTE_TO_LAN) Then
                  If curConnecting.ShowErrors Then
                     RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "Es konnte keine Verbindung zu ''" & ChatNick & "'' hergestellt werden.")
                  Else
                     RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "")
                  End If
                  Call modClient.ConnectionCancel(ChatNick)
                  Call QuitConnecting(ChatNick, True)
               Else
                  'wait for answer'
                  Call curConnecting.StartTimeOut(5)
                  curConnecting.ConnectingState = "CREATE_ROUTE_TO_LAN"
                  dlgWorking.tmrConnectingTimer.Enabled = True
               End If
            End If
         
         Case "CREATE_ROUTE_TO_LAN"
            'routing error'
            If curConnecting.ShowErrors Then
               RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "Es konnte keine Verbindung zu ''" & ChatNick & "'' hergestellt werden.")
            Else
               RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "")
            End If
            Call modClient.ConnectionCancel(ChatNick)
            Call QuitConnecting(ChatNick, True)
         
         Case "START_CONNECTING"
            'no connection'
            If curConnecting.ShowErrors Then
               RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "Es konnte keine Verbindung zu ''" & ChatNick & "'' hergestellt werden.")
            Else
               RaiseEvent CancelConnecting(curConnecting.DstRemoteIP, curConnecting.DstName, curConnecting.ChatId, curConnecting.ConnectionType, "")
            End If
            Call modClient.ConnectionCancel(ChatNick)
            Call QuitConnecting(ChatNick, True)
         
         Case Else
            'NOP'
      
      End Select
   
   End If

   Exit Sub

ErrorHandler:
   On Local Error Resume Next
   Set dlgWorking = dlgWorkings(LCase$(ChatNick))
   dlgWorking.tmrConnectingTimer.Enabled = False
   MsgBox "Verbindungsfehler", vbCritical + vbOKOnly, "DEBUG"
   'NOP'

End Sub

Public Sub ConnectionEstablished(strRemoteIP As String, strUser As String)
   On Local Error GoTo ErrorHandler
   Dim curConnecting As New clsConnecting
   Dim dlgWorking As New dlgConnectingState
      
   Set curConnecting = Connectings(LCase$(strUser))
   Set dlgWorking = dlgWorkings(LCase$(strUser))
   
   curConnecting.IsConnected = True
   curConnecting.ConnectingState = "CONNECTED"
   dlgWorking.tmrConnectingTimer.Enabled = False
   If curConnecting.ConnectionType = "CHAT" Then
      dlgWorking.AddDebugMsg = "Start ChatWindow"
      Call CreateChat(strRemoteIP, strUser, curConnecting.ChatId, curConnecting.IsPrimaryHost)
   Else
      RaiseEvent GotConnection(curConnecting.DstRemoteIP, curConnecting.DstName, "", curConnecting.ChatId, curConnecting.ConnectionType)
      Call QuitConnecting(curConnecting.DstName)
   End If
   
   Exit Sub
   
ErrorHandler:
   'NOP'
   
End Sub

Private Sub CreateChat(strRemoteIP As String, strUser As String, ChatId As String, IsHost As Boolean)
   Dim ChatWindow As dlgChat
   Dim PrimaryHost As ClientProperties
   Dim SecondaryHost As ClientProperties

   If Not ExistChatWindow(ChatId) Then Exit Sub
   Set ChatWindow = ChatWindows(ChatId)

   If IsHost Then

      'set chat properties'
      PrimaryHost.cpUsername = modClient.LocalUser.cpUsername
      PrimaryHost.cpRemoteIP = modClient.LocalUser.cpRemoteIP
      PrimaryHost.cpLAN_IP = modClient.LocalUser.cpLAN_IP
      SecondaryHost.cpUsername = strUser
      SecondaryHost.cpRemoteIP = dlgMain.ClientManagement.GetClientRemoteIP(strUser)
      SecondaryHost.cpLAN_IP = dlgMain.ClientManagement.GetClientLAN_IP(strUser)
      Call ChatWindow.SetPrimaryHost(PrimaryHost.cpUsername, PrimaryHost.cpRemoteIP, PrimaryHost.cpLAN_IP)
      Call ChatWindow.SetSecondaryHost(SecondaryHost.cpUsername, SecondaryHost.cpRemoteIP, SecondaryHost.cpLAN_IP)
   
      'send chat properties'
      Call MyConnection.clsWinSock_SendDatas( _
         Encoder.GetCommandLine("CHAT_PROPERTIES", _
            ChatId, _
            PrimaryHost.cpUsername, _
            PrimaryHost.cpRemoteIP, _
            PrimaryHost.cpLAN_IP, _
            SecondaryHost.cpUsername, _
            SecondaryHost.cpRemoteIP, _
            SecondaryHost.cpLAN_IP _
         ), _
         strRemoteIP, _
         strUser _
      )

   Else
      'chat properties required'

   End If

   'create key'
   Call EstablishIMBasics(strRemoteIP, strUser)

End Sub

Public Sub QuitConnecting(ChatNick As String, Optional RemoveWorking As Boolean = False)
   On Local Error Resume Next
   Dim curConnecting As New clsConnecting
   Dim dlgWorking As New dlgConnectingState
   
   Set curConnecting = Connectings(LCase$(ChatNick))
   If RemoveWorking Then Set dlgWorking = dlgWorkings(LCase$(ChatNick))

   Call Connectings.Remove(LCase$(ChatNick))
   If RemoveWorking Then Call dlgWorkings.Remove(LCase$(ChatNick))

   Unload dlgWorking
   Set curConnecting = Nothing
   If RemoveWorking Then Set dlgWorking = Nothing

End Sub

Public Function ExistChatWindow(WindowKey As String) As Boolean
   On Local Error GoTo ErrorHandler
   Dim TestWindow As dlgChat
   ExistChatWindow = True
   Set TestWindow = ChatWindows(WindowKey)
   Exit Function
ErrorHandler:
   ExistChatWindow = False
End Function

'Added 31.05.2005 ShellExtension
Public Function ExistChatWindowByName(ChatNick As String) As Boolean
   On Local Error GoTo ErrorHandler
   Dim TestWindow As dlgChat
   
   For Each TestWindow In ChatWindows
    'Set TestWindow = ChatWindows(WindowKey)
    If TestWindow.CountClients = 1 Then
        If LCase$(TestWindow.LastChatNick) = LCase$(ChatNick) Then
            ExistChatWindowByName = True
            Exit For
        End If
    End If
   Next
   
   Exit Function
ErrorHandler:
   ExistChatWindowByName = False
End Function

Public Function GetChatId(ChatNick As String) As String
   On Local Error Resume Next

   Dim curConnecting As clsConnecting
   Set curConnecting = Connectings(LCase$(ChatNick))

   GetChatId = curConnecting.ChatId

End Function

Public Function CreateChatId(IdLength As Long) As String
   Dim I As Long
   CreateChatId = ""
   For I = 1 To IdLength
      Randomize Timer
      CreateChatId = CreateChatId & Chr$(Int(Rnd * 25) + 65)
   Next I
   CreateChatId = CreateChatId & "@" & LocalUser.cpUsername
   CreateChatId = LCase$(CreateChatId)
End Function
