VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CParser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const Delimiter As String = "|"
Private Const ESCAPE    As String = "\"
Private Const NEWLINE   As String = "n"
Private Const NULLCHAR  As String = "0"
Private Const EOS       As String = vbCr
'----------------------------------------------------

Private Enum TokenType
    TT_Nothing
    TT_Identifier
    TT_Constant
    
    TT_Error = -1
End Enum

Private Type Token
    TType   As TokenType
    Value   As String
End Type
'----------------------------------------------------

Private m_Command   As String
Private m_Position  As Long
Private m_Error     As Boolean
Private m_ErrorDescription As String
'----------------------------------------------------

Property Get Error() As Boolean
   Error = m_Error
End Property
Property Get ErrorDescription() As String
   ErrorDescription = m_ErrorDescription
End Property

Public Sub CropHeader(ByRef Data As String)
    Dim StartPos    As Long
    
    StartPos = InStrB(1, Data, vbCrLf & vbCrLf)
    
    If StartPos > 0 Then _
        Data = MidB$(Data, StartPos + 4)
End Sub

Public Function Parse(CommandLine As String, Optional strRemoteIP As String, Optional strChatNick As String) As Boolean
    Dim Statements() As String
    Dim I            As Long
    Dim Key          As String
    
    If LenB(CommandLine) = 0 Then _
        Exit Function
    
    If LeftB$(CommandLine, LenB(CRYPTO_HEADER)) = CRYPTO_HEADER And strRemoteIP <> "" And strChatNick <> "" Then
        Key = Keys.FindKey(strRemoteIP, strChatNick)
        If Not Key = "" Then
            Dim src()   As Byte
            Dim tgt()   As Byte
            
            Call String_to_byteArray(MidB$(CommandLine, LenB(CRYPTO_HEADER) + 1), src)
            Call CryptoInstance.Crypt(src, tgt, Key, True)
            CommandLine = byteArray_to_string(tgt)
        End If
    End If
    Statements = Split(CommandLine, vbCrLf)
    
    For I = 0 To UBound(Statements)
        Call Reset(Statements(I))
        Call Statement
        
        If m_Error Then _
            Exit For
    Next I
    
    Parse = Not m_Error
End Function
'----------------------------------------------------

Private Sub Execute(cmd As String, Parameters As CStringStack)
    Select Case UCase$(cmd)
        Case "ALIVE"
        Case "AVAILABLE"
            ' reply from other client whether specific command is available
            ' 1st parameter: "True" or "False"
            ' 2nd parameter: requested command
        Case "CODE"
            ' code was sent by
            ' 1st parameter: code
            ' 2nd parameter: remote user
            Call modConnection.IncommingCode( _
                SenderNick:=Parameters.Pop(), _
                Data:=Parameters.Pop(), _
                ChatId:=Parameters.Pop() _
            )
        Case "CODEDATA" ' !!!!! '
            ' TODO: NEW CODE FORMAT 18/03/2005
            ' code has been received
            ' 1st parametre: UID (system unique identifier)
            ' 2nd parametre: remote user
            ' 3rd parametre: code title
            ' 4th parametre: code
            Call modConnection.IncomingCode( _
                UID:=Parameters.Pop(), _
                SenderNick:=Parameters.Pop(), _
                CodeTitle:=Parameters.Pop(), _
                Code:=Parameters.Pop() _
            )
        Case "CONNECT"
        Case "DISCONNECT"
        Case "ERR"
            'Changed at 23.10.04 by Kai
            ' forget it -- server returns an error
            ' 1st parameter: my IP
            'MyIP = Parameters.Pop()
            m_Error = True
            'm_ErrorDescription = Parameters.Pop()
            Dim TempStr As String
            Dim OutStr As String

            Do
                TempStr = Parameters.Pop()
                If Len(TempStr) = 0 Then Exit Do
                OutStr = TempStr & "|" & OutStr
            Loop
            
            If Len(OutStr) Then OutStr = Left$(OutStr, Len(OutStr) - 1)
            m_ErrorDescription = OutStr
        Case "FUNCTIONTEST"
            ' testet, ob die aktuelle Version eine bestimmte Funktion implementiert
            ' 1st parameter: remote IP
            ' 2nd parameter: command
            Call TestOnFunctionAvail( _
                RemoteIP:=Parameters.Pop(), _
                cmd:=Parameters.Pop() _
            )
        Case "STATE_MESSAGE_REQUEST"
            ' 1st parameter: remote IP
            ' 2nd parameter: sender nick
            Call GotStateMessageRequest( _
                SenderNick:=Parameters.Pop(), _
                RemoteIP:=Parameters.Pop() _
            )
        Case "MSG"
            ' 1st parameter: chat id
            ' 2nd parameter: remote IP
            ' 3rd parameter: message
            ' 4th parameter: sender nick
            Call IncomingData( _
                SenderNick:=Parameters.Pop(), _
                Data:=Parameters.Pop(), _
                RemoteIP:=LastChatIP, _
                ChatId:=Parameters.Pop() _
            )
        Case "MSGOK"
            ' 1st parameter: message sernder IP
            ' 2nd parameter: message sender
            ' 3rd parameter: chat id
            ' 4th parameter: sender nick
            Call GotMessageOk( _
                SenderNick:=Parameters.Pop(), _
                ChatId:=Parameters.Pop(), _
                MessageSender:=Parameters.Pop(), _
                MessageSenderIP:=Parameters.Pop() _
            )
        Case "REMOTE_TYPING"
            ' 1st parameter: chat id
            ' 2nd parameter: typing state
            ' 3rd parameter: sender nick
            Call RemoteTyping( _
                SenderNick:=Parameters.Pop(), _
                TypingState:=CBool(CInt(Parameters.Pop())), _
                ChatId:=Parameters.Pop() _
            )
        Case "OK"
            'm_Error = False
            ' 1st parameter: my IP
            MyIP = Parameters.Pop()
            modClient.LocalUser.cpRemoteIP = MyIP
            
        Case "USER"
            ' set data of a user
            ' 1st parameter: LAN IP
            ' 2nd parameter: online state (default: cosOnline)
            ' 3rd parameter: user IP
            ' 4th parameter: user nick
            Call dlgMain.ClientManagement.SetClient( _
                NickName:=Parameters.Pop(), _
                RemoteIP:=Parameters.Pop(), _
                iOnlineState:=CLng(Parameters.Pop(CStr(cosOnline))), _
                ForceChange:=True, _
                LAN_IP:=Parameters.Pop() _
            )
        Case "PARAM"
            ' set Parameter for App
            ' 1st Parameter: Param-Typ
            ' 2nd Parameter: Param-Value
            Call modMain.ExecuteParameters( _
                ParamType:=Parameters.Pop(), _
                ParamValue:=Parameters.Pop() _
            )
        Case "CRYPT_SEND_BASICS"
            ' get basic key exchange datas
            ' 1st parameter: beta
            ' 2nd parameter: G
            ' 3rd parameter: P
            ' 4th parameter: sender nick
            Call MyCreateConnection.GotSecureBasics( _
                m_RemoteIP:=LastChatIP, _
                beta:=CLng(Parameters.Pop()), _
                G:=CLng(Parameters.Pop()), _
                p:=CLng(Parameters.Pop()), _
                m_ChatNick:=Parameters.Pop() _
            )
        Case "CRYPT_SEND_PW"
            ' get crypted key for further coding
            ' 1st parameter: coded key
            ' 2nd parameter: sender nick
            Call MyCreateConnection.GotKey( _
                m_RemoteIP:=LastChatIP, _
                Key:=Parameters.Pop(), _
                m_ChatNick:=Parameters.Pop(), _
                ChatId:=Parameters.Pop() _
            )
        Case "CRYPT_SEND_BETA"
            ' get key exchange response (beta)
            ' 1st parameter: beta
            ' 2nd parameter: sender nick
            Call MyCreateConnection.EstablishSecureIM( _
                m_RemoteIP:=LastChatIP, _
                beta:=CLng(Parameters.Pop()), _
                m_ChatNick:=Parameters.Pop() _
            )
        Case "DELETE_KEY"
            'delete key for crypting
            '1st parameter: sender nick
            Call Keys.DeleteKey( _
                strIP:=LastChatIP, _
                ChatNick:=Parameters.Pop(), _
                OnlyDelete:=True _
            )
        Case "IGNORE"
            'user don't want to talk to me
            '1st parameter: sender nick
            Call MyCreateConnection.Ignored( _
                m_RemoteIP:=LastChatIP, _
                m_ChatNick:=Parameters.Pop() _
            )
        Case "AUTHORIZATION_REQUEST"
            'user wants a authorization
            '1st parameter: sender nick
            Call MyCreateConnection.AuthorizationRequest( _
                m_RemoteIP:=LastChatIP, _
                m_ChatNick:=Parameters.Pop() _
            )
        Case "AUTHORIZATION_RESPONSE"
            'got authorization request response
            Call MyCreateConnection.GotAuthorizationResponse( _
                m_RemoteIP:=LastChatIP, _
                Accepted:=CBool(Parameters.Pop()), _
                m_ChatNick:=Parameters.Pop() _
            )
        Case "STATEMSG"
            ' got a online state message
            ' 1st parameter: state message
            ' 2nd parameter: online state
            ' 3rd parameter: user IP
            ' 4th parameter: user nick
            Call MyCreateConnection.ReceiveStateMessage( _
                NickName:=Parameters.Pop(), _
                RemoteIP:=Parameters.Pop(), _
                iOnlineState:=Parameters.Pop(), _
                StateMessage:=Parameters.Pop() _
            )
        Case "CHAT_PROPERTIES"
            ' got chat properties
            ' 1st parameter: chat id
            ' 2nd parameter: primary host name
            ' 3rd parameter: primary host IP
            ' 4th parameter: primary host LAN IP
            ' 5th parameter: secondary host name
            ' 6th parameter: secondary host IP
            ' 7th parameter: secondary host LAN IP
            Call modChat.SetChatProperties( _
                SecondaryLAN_IP:=Parameters.Pop(), _
                SecondaryRemoteIP:=Parameters.Pop(), _
                SecondaryNick:=Parameters.Pop(), _
                PrimaryLAN_IP:=Parameters.Pop(), _
                PrimaryRemoteIP:=Parameters.Pop(), _
                PrimaryNick:=Parameters.Pop(), _
                ChatId:=Parameters.Pop() _
            )
        Case "CHAT_INVITATION"
            ' got a chat invitation
            ' 1st parameter: chat id
            ' 2nd parameter: primary host name
            ' 3rd parameter: primary host IP
            ' 4th parameter: primary host LAN IP
            Call modChat.GotChatInvitation( _
                PrimaryLAN_IP:=Parameters.Pop(), _
                PrimaryRemoteIP:=Parameters.Pop(), _
                PrimaryNick:=Parameters.Pop(), _
                ChatId:=Parameters.Pop() _
            )
        Case "CHAT_ADDCLIENT"
            ' add client to chat
            ' 1st parameter: chat id
            ' 2nd parameter: online state
            ' 3rd parameter: remote ip
            ' 4th parameter: nick name
            Call modChat.AddClientToConference( _
                NickName:=Parameters.Pop(), _
                RemoteIP:=Parameters.Pop(), _
                ChatId:=Parameters.Pop() _
            )
        Case "CHAT_REMOVECLIENT"
            ' remove client from chat
            ' 1st parameter: chat id
            ' 2nd parameter: nick name
            Call modChat.RemoveClientFromConference( _
                NickName:=Parameters.Pop(), _
                ChatId:=Parameters.Pop() _
            )
        
    End Select
End Sub
'----------------------------------------------------

' parser

Private Sub Statement()
    Dim CurrToken   As Token
    Dim cmd         As String
    Dim Parameters  As CStringStack
    
    Set Parameters = New CStringStack
    
    Do
        CurrToken = GetNextToken()
        
        Select Case CurrToken.TType
            Case TT_Constant
                Call Parameters.Push(CurrToken.Value)
            Case TT_Error
                m_Error = True
                Exit Sub
            Case TT_Identifier
                If Not CBool(LenB(cmd)) Then _
                    cmd = CurrToken.Value _
                Else _
                    Call Parameters.Push(CurrToken.Value)
            Case TT_Nothing
                Exit Do
        End Select
    Loop
    
    If CBool(LenB(cmd)) Then _
        Call Execute(cmd, Parameters)
End Sub
'----------------------------------------------------

' scanner

Private Sub Reset(CommandLine As String)
    m_Command = CommandLine
    m_Error = False
    m_Position = 1
End Sub

Private Function GetNextToken() As Token
    Dim Char    As String * 1
    Dim LastChr As String * 1
    
    Do
        Char = GetChar()
        
        Select Case Char
            Case Delimiter, EOS, vbNullChar
                If LastChr = ESCAPE Then
                    GetNextToken.Value = GetNextToken.Value & Delimiter
                    LastChr = Delimiter
                Else
                    ' return token
                    If Not CBool(LenB(GetNextToken.Value)) Then
                        GetNextToken.TType = TT_Nothing
                    ElseIf IsNumeric(GetNextToken.Value) Then
                        GetNextToken.TType = TT_Constant
                    Else
                        GetNextToken.TType = TT_Identifier
                    End If
                    
                    Exit Function
                End If
            Case ESCAPE
                If LastChr = ESCAPE Then
                    GetNextToken.Value = GetNextToken.Value & ESCAPE
                    LastChr = " "
                Else
                    LastChr = ESCAPE
                End If
            Case NEWLINE
                If LastChr = ESCAPE Then
                    GetNextToken.Value = GetNextToken.Value & vbCr
                    LastChr = " "
                Else
                    GetNextToken.Value = GetNextToken.Value & NEWLINE
                End If
            Case NULLCHAR
                If LastChr = ESCAPE Then
                    GetNextToken.Value = GetNextToken.Value & vbNullChar
                    LastChr = " "
                Else
                    GetNextToken.Value = GetNextToken.Value & NULLCHAR
                End If
            Case Else
                GetNextToken.Value = GetNextToken.Value & Char
                LastChr = Char
        End Select
    Loop
End Function

Private Function GetChar() As String
    If m_Position > LenB(m_Command) Then
        GetChar = vbNullChar
        Exit Function
    End If
    
    GetChar = MidB$(m_Command, m_Position, 2)
    m_Position = m_Position + 2
End Function

'Private Sub UngetChar()
'    m_Position = m_Position - 2
'    If m_Position < 1 Then _
'        m_Position = 1
'End Sub
