VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'**********************************************************
'*  Klasse fr das Verwalten von Benutzern
'*
'*  Erstellt von Bjrn Tschrtner (bat_ware@surfeu.de)
'*  Letzte nderung: 26.02.2004
'*  Version: 1.22
'**********************************************************

'Private Const ModuleVersion As String = "1.22"

Public Event DataChange(NickName As String, RemoteIP As String, OnlineState As ClientOnlineState, Relationship As ClientRelationship)
Public Event NewClient(NickName As String, RemoteIP As String, OnlineState As ClientOnlineState, Relationship As ClientRelationship)
Public Event RemoveClient(NickName As String, Relationship As ClientRelationship)
Public Event ClientConnectionError(NickName As String)

Dim Client() As ClientProperties

Private Sub Class_Initialize()
   ReDim Client(0)
   Client(0).cpUsername = ""

End Sub

Public Sub SetLocalUser(Optional NickName As String = "", Optional LocalIP As String = "", Optional iOnlineState As ClientOnlineState = cosOnline)
   'set or update data of local user'
   
   If NickName = "" Then NickName = modClient.LocalUser.cpUsername
   If LocalIP = "" Then LocalIP = modClient.LocalUser.cpRemoteIP
   
   modClient.LocalUser.cpRemoteIP = LocalIP
   modClient.LocalUser.cpOnlineState = iOnlineState
   
   If modClient.LocalUser.cpUsername = "" Then
      modClient.LocalUser.cpUsername = NickName
      RaiseEvent NewClient(NickName, LocalIP, iOnlineState, crNone)
   
   Else
      modClient.LocalUser.cpUsername = NickName
      RaiseEvent DataChange(NickName, LocalIP, iOnlineState, crNone)
   
   End If
   
   If NickName <> "" And iOnlineState <> cosOffline And iOnlineState <> cosUnknown Then
      'load client lists on login'
      Call LoadClientsLists
      
      'notify clients about my online state'
      Call SendMyOnlineState
      
   End If

End Sub

Public Sub ClearClientList()
   ReDim Client(0)
   Client(0).cpUsername = ""
   modClient.LocalUser.cpUsername = ""

End Sub

Public Function SetClient(NickName As String, Optional ByVal RemoteIP As String = "", Optional ByVal iOnlineState As ClientOnlineState = -99, Optional ByVal LAN_IP As String = "", Optional ForceChange As Boolean = False) As Long
   On Local Error GoTo ErrorHandler
   'add a client to the list or update data'
   Dim I As Long
   Dim resSearch As Long
   Dim res As Long
   Dim Relationship As ClientRelationship
   Dim oldOnlineState As ClientOnlineState
   
   resSearch = -1
   oldOnlineState = -99
   
   If UCase$(NickName) = UCase$(modClient.LocalUser.cpUsername) Then Exit Function

'DEBUG'
'   If NickName = "Bjrn (PC_2)" Then RemoteIP = "192.168.1.3"

   If (iOnlineState = cosOffline Or iOnlineState = cosUnknown) And GetClientRelationship(NickName, True) = crNone And SearchClient(NickName) = -1 Then
      'just add offline users when they are in a list'
      Exit Function
   End If
   
   'check if the client already exists and update client data'
   If IsClientListDim(Client) Then
      For I = 0 To UBound(Client)
         If UCase$(Client(I).cpUsername) = UCase$(NickName) Then
            'update client data'
            If (iOnlineState <> -99) And (ForceChange = True) Then
               If Client(I).cpOnlineState = cosOffline And iOnlineState > cosOffline And GetClientRelationship(Client(I).cpUsername) = crFriend Then
                  'client came online'
                  PlaySound sndNewUser
               
                    ' klmr on 09/03/2005 '
                    Dim NifDlg As New NotifyDialog
                    
                    Call NifDlg.Create( _
                        "ActiveVB Messenger", " hat sich angemeldet.", _
                        NickName, Effect:=ScrollUpDown _
                    )
               End If
               oldOnlineState = Client(I).cpOnlineState
               Client(I).cpOnlineState = iOnlineState
            Else
               iOnlineState = Client(I).cpOnlineState
            End If
            'Remote IP updaten oder auslesen
            If RemoteIP <> "" Then
               Client(I).cpRemoteIP = RemoteIP
            Else
               RemoteIP = Client(I).cpRemoteIP
            End If
            'LAN IP updaten oder auslesen
            If LAN_IP <> "" Then
               Client(I).cpLAN_IP = LAN_IP
            Else
               LAN_IP = Client(I).cpLAN_IP
            End If
            Call UpdateClientRelationship(, I)
            Relationship = Client(I).cpRelationship
            
            If Client(I).cpOnlineState <> cosOffline And Client(I).cpOnlineState <> cosUnknown Then
               Client(I).cpStillLoggedIn = True
            End If
            
            resSearch = I
         
            'set offline state'
            If Client(I).cpOnlineState = cosOffline Then
               'remove offline client'
               Call RemoveClient(, I)
               
'               If Client(I).cpRelationship <> crFriend And Client(I).cpRelationship <> crUnwanted Then
'                  'remove offline client'
'                  Call RemoveClient(, I)
'               End If
            End If
         
         End If
      Next I
   
      'add new field'
      If resSearch = -1 And Client(UBound(Client)).cpUsername <> "" Then
         ReDim Preserve Client(UBound(Client) + 1)
      End If
   
   Else
      'create first field'
      ReDim Preserve Client(0)
   
   End If

   'create new client entry'
   If resSearch = -1 Then
      With Client(UBound(Client))
         .cpUsername = NickName
         .cpOnlineState = iOnlineState
         .cpRemoteIP = RemoteIP
         .cpLAN_IP = LAN_IP
         .cpStillLoggedIn = True
         
         Call UpdateClientRelationship(, UBound(Client))
         Relationship = .cpRelationship

         RaiseEvent NewClient(NickName, RemoteIP, iOnlineState, .cpRelationship)
      
      End With
   End If

   If iOnlineState <> cosOffline Then RaiseEvent DataChange(NickName, RemoteIP, iOnlineState, Relationship)

   'notify each connected client about this user'
   If oldOnlineState <> iOnlineState And Not ((iOnlineState = cosOffline Or iOnlineState = cosUnknown) And GetClientRelationship(NickName, True) <> crNone) Then
      Call SendOnlineStateNotification(NickName)
   End If

   Exit Function

ErrorHandler:
   'NOP'
   
End Function

Public Function RemoveClient(Optional NickName As String = "", Optional Index As Long = -1) As Long
   'remove client'
   Dim I As Long
   Dim resSearch As Long
      
   resSearch = -1
   
   'search client'
   If IsClientListDim(Client) Then
      For I = 0 To UBound(Client)
         If I > UBound(Client) Then Exit For
         
         If Index <> -1 Then I = Index
         
         If UCase$(Client(I).cpUsername) = UCase$(NickName) Or Index = I Then
            resSearch = I
            
            If Client(I).cpRelationship <> crFriend And Client(I).cpRelationship <> crUnwanted Then
            
               RemoveClient = -1
               RaiseEvent RemoveClient(Client(I).cpUsername, Client(I).cpRelationship)
               
               If I <> UBound(Client) Then Client(I) = Client(UBound(Client))
               If UBound(Client) > 0 Then
                  ReDim Preserve Client(UBound(Client) - 1)
                  If Index = I Then Exit For
               Else
                  ReDim Client(0)
                  Exit For
               End If
                 
            Else
               RemoveClient = 0
               Client(I).cpOnlineState = cosOffline
               RaiseEvent DataChange(Client(I).cpUsername, Client(I).cpRemoteIP, Client(I).cpOnlineState, Client(I).cpRelationship)
               Exit For
                 
            End If
                     
         End If
      
      Next I
   
   Else
      RaiseEvent RemoveClient(NickName, crNone)
   
   End If

End Function

Public Sub ResetUnknownState(NickName As String)
   Dim ClientId As Long
   ClientId = SearchClient(NickName)

   If ClientId = -1 Then
      'client not found'
      Exit Sub
   Else
      If Client(ClientId).cpOnlineState = cosUnknown Then
         Client(ClientId).cpOnlineState = cosOnline
         RaiseEvent DataChange(Client(ClientId).cpUsername, Client(ClientId).cpRemoteIP, Client(ClientId).cpOnlineState, Client(ClientId).cpRelationship)
      End If
   End If

End Sub

Public Function GetClientName(Optional RemoteIP As String = "", Optional Index As Long = -1, Optional OnlyOnline As Boolean) As String
   Dim I As Long

   If Not IsClientListDim(Client) Then Exit Function

   'search client'
   For I = 0 To UBound(Client)
      If OnlyOnline Then
        If Client(I).cpOnlineState <> cosOffline And Client(I).cpOnlineState <> cosUnknown Then
            If Index = 0 Then
                GetClientName = Client(I).cpUsername
                Exit For
            End If
            Index = Index - 1
        End If
      Else
        If Index <> -1 Then I = Index
        If UCase$(Client(I).cpRemoteIP) = UCase$(RemoteIP) Or I = Index Then
           GetClientName = Client(I).cpUsername
           Exit For
        End If
      End If
   Next I

End Function

Public Function GetClientRemoteIP(NickName As String) As String
   Dim I As Long

   If Not IsClientListDim(Client) Then Exit Function

   'search client'
   For I = 0 To UBound(Client)
      If UCase$(Client(I).cpUsername) = UCase$(NickName) Then
         GetClientRemoteIP = Client(I).cpRemoteIP
         Exit For
      End If
   Next I

End Function

Public Function GetClientLAN_IP(NickName As String) As String
   Dim ClientId As Long
   ClientId = SearchClient(NickName)
   If ClientId <> -1 Then
      GetClientLAN_IP = Client(ClientId).cpLAN_IP
   Else
      GetClientLAN_IP = ""
   End If
End Function

Public Function GetOptimallyIP(NickName As String, Optional DefaultIP As String = "") As String
   Dim ClientId As Long
   ClientId = SearchClient(NickName)
   If ClientId <> -1 Then
      If DefaultIP = "" Then DefaultIP = Client(ClientId).cpRemoteIP
      If Client(ClientId).cpRemoteIP <> LocalUser.cpRemoteIP Then
         GetOptimallyIP = Client(ClientId).cpRemoteIP
      Else
         GetOptimallyIP = Client(ClientId).cpLAN_IP
      End If
   Else
      GetOptimallyIP = DefaultIP
   End If
   If GetOptimallyIP = "" Then GetOptimallyIP = DefaultIP
End Function

Public Function GetClientOnlineState(NickName As String) As ClientOnlineState
   Dim ClientId As Long
   ClientId = SearchClient(NickName)
   If ClientId = -1 Then
      GetClientOnlineState = -99
   Else
      GetClientOnlineState = Client(ClientId).cpOnlineState
   End If
End Function

Public Function SearchClient(Optional NickName As String = "", Optional RemoteIP As String = "") As Long
   Dim I As Long

   SearchClient = -1
   If Not IsClientListDim(Client) Then Exit Function

   'search client'
   For I = 0 To UBound(Client)
      If (UCase$(Client(I).cpUsername) = UCase$(NickName) And NickName <> "") Or (UCase$(Client(I).cpRemoteIP) = UCase$(RemoteIP) And RemoteIP <> "") Then
         SearchClient = I
         Exit For
      End If
   Next I

End Function

Public Function GetDirName(NickName As String) As String
   GetDirName = NickName
   GetDirName = Replace(GetDirName, "/", "_")
   GetDirName = Replace(GetDirName, "\", "_")
   GetDirName = Replace(GetDirName, ":", "_")
   GetDirName = Replace(GetDirName, "*", "_")
   GetDirName = Replace(GetDirName, "?", "_")
   GetDirName = Replace(GetDirName, Chr$(34), "_")
   GetDirName = Replace(GetDirName, "<", "_")
   GetDirName = Replace(GetDirName, ">", "_")
   GetDirName = Replace(GetDirName, "|", "_")

End Function

Public Function GetSortedNames(resArray() As String, Optional OnlyOnlineClients As Boolean = False) As Long
   'returns a sorted client list'
   Dim I As Long
   Dim SortComplete As Boolean
   Dim tmpName As String

   If Not IsClientListDim(Client) Then
      ReDim resArray(0)
      GetSortedNames = 0
      Exit Function
   End If

   Erase resArray
   ReDim resArray(0)

   'copy names'
   For I = 0 To UBound(Client)
      If Client(I).cpOnlineState > cosOffline Or (Not OnlyOnlineClients) Then
         If Not (UBound(resArray) = 0 And resArray(0) = "") Then
            ReDim Preserve resArray(UBound(resArray) + 1)
         End If
         resArray(UBound(resArray)) = Client(I).cpUsername
         GetSortedNames = GetSortedNames + 1
      End If
   Next I

   'sort names'
   Do
      For I = 0 To UBound(resArray) - 1
         SortComplete = True
         If resArray(I) > resArray(I + 1) Then
            tmpName = resArray(I + 1)
            resArray(I + 1) = resArray(I)
            resArray(I) = tmpName
            SortComplete = False
         End If
      Next I
   Loop Until SortComplete Or UBound(resArray) = 0

   'GetSortedNames = -1

End Function

Public Function BroadcastConnectedClients(Optional strData As String = "") As Long
   'send broadcast data to each connected client'
   Dim I As Long

   If Not IsClientListDim(Client) Then Exit Function

   For I = 0 To UBound(Client)
      Call MyConnection.clsWinSock_SendDatas(strData, GetOptimallyIP(Client(I).cpUsername, Client(I).cpRemoteIP), Client(I).cpUsername, , , , False, True)
'      Call MyConnection.clsWinSock_SendDatas(strData, Client(i).cpRemoteIP, Client(i).cpUsername, , , , False, True)
   
   Next I

End Function

Public Function SendBroadcast(Optional strData As String = vbNullString, Optional strForwardTo As String = vbNullString, Optional strForwardToUser As String = vbNullString) As Long
   'send a message to all clients and return the number of errors'
   Dim I As Long
   Dim res As Long

   If Not IsClientListDim(Client) Then Exit Function

   'send data to each client'
   For I = 0 To UBound(Client)

      If UCase$(Client(I).cpRemoteIP) <> UCase$(strForwardTo) And UCase$(Client(I).cpRemoteIP) <> "" Then
         res = MyConnection.clsWinSock_SendDatas(vbNullString, Client(I).cpRemoteIP, Client(I).cpUsername, strData, strForwardTo, strForwardToUser, , True)

         If Not res Then
            'connection error'
            SendBroadcast = SendBroadcast + 1

            'remove client and send a message to all clients'
'           Call RemoveClient(Client.cpUsername)
'           Blabla...

            RaiseEvent ClientConnectionError(Client(I).cpUsername)
            DoEvents

         End If
      End If

   Next I

End Function

Public Function OpenMessageHistory(NickName As String) As Long
   Dim ClientId As Long
   
   ClientId = SearchClient(NickName)

   If ClientId = -1 Then
      'client not found'
      OpenMessageHistory = -1
      Exit Function
   End If

   If Not IsFormLoaded(Client(ClientId).cpMessageHistory) Then
      'open new message history'
      Set Client(ClientId).cpMessageHistory = New dlgMessageHistory
      Client(ClientId).cpMessageHistory.Show
      Client(ClientId).cpMessageHistory.ShowMessageHistory (Client(ClientId).cpUsername)
      OpenMessageHistory = 0

   Else
      'activate message history'
      Client(ClientId).cpMessageHistory.Show
      If Client(ClientId).cpMessageHistory.WindowState = 1 Then Client(ClientId).cpMessageHistory.WindowState = 0
      OpenMessageHistory = 0
   
   End If

End Function

Public Function StartFileTransfer(NickName As String, FileName As String, FileLength As Long, Sending As Boolean) As Long
   Dim ClientId As Long
   'Dim TransferClientId As Long
   
   ClientId = SearchClient(NickName)

   If ClientId = -1 Then
      'client not found'
      StartFileTransfer = -1
      Exit Function
   End If

   If Not IsFormLoaded(Client(ClientId).cpTransferForm) Then
      
'      'search other transfers'
'      TransferClientId = CurrentFileTransferClient()
'      If TransferClientId <> -1 Then
'         If Sending Then
'            MsgBox "Es luft bereits ein Transfer mit ''" & Client(TransferClientId).cpUsername & "''." & vbCrLf & "Sie knnen immer nur einen Transfer durchfhren.", vbOKOnly + vbExclamation, "Dateitransfer"
'            StartFileTransfer = -3
'            Exit Function
'         Else
'            'NOP'
'         End If
'      End If
      
      'start new file transfer'
      Set Client(ClientId).cpTransferForm = New dlgFileTransfer
            
      If Sending Then
         Client(ClientId).cpTransferForm.Show
      Else
         If modSettings.GetSetting("WindowMode", "State") = "0" Then
            Client(ClientId).cpTransferForm.WindowState = vbMinimized
            Client(ClientId).cpTransferForm.Visible = True
         Else
            Call Client(ClientId).cpTransferForm.Show
         End If
      End If
            
      Client(ClientId).cpTransferForm.Sending = Sending
      Client(ClientId).cpTransferForm.FileName = FileName
      Client(ClientId).cpTransferForm.NickName = NickName
      Client(ClientId).cpTransferForm.RemoteIP = Client(ClientId).cpRemoteIP
      Client(ClientId).cpTransferForm.FileLength = FileLength
      
'      Client(ClientId).cpTransferForm.SetFocus
      
      If Sending Then
         Call dlgMain.Connection.clsWinSock_SendFile(FileName, Client(ClientId).cpRemoteIP, NickName)
      Else
         Call FlashForm(Client(ClientId).cpTransferForm.hwnd, Client(ClientId).cpTransferForm.tmrFlashForm, True)
         PlaySound sndFileTransfer
      End If
      
      StartFileTransfer = 0

   Else
      'file transfer is already running'
      StartFileTransfer = -2
   
   End If

End Function

Public Sub ProgressFileTransfer(NickName As String, ReceivedBytes As Long)
   Dim ClientId As Long
   
   ClientId = SearchClient(NickName)
   
   If ClientId <> -1 And LCase$(TypeName$(Client(ClientId).cpTransferForm)) <> "nothing" Then
      Call Client(ClientId).cpTransferForm.SetTransferState(ReceivedBytes)
   
   Else
      'client not found'
      MsgBox "Fehler bei Dateitransfer mit ''" & Client(ClientId).cpUsername & "''.", vbOKOnly + vbCritical, "Fehler"
   
   End If

End Sub

Public Sub QuitFileTransfer(NickName As String, bolAbbort As Boolean, bolFaild As Boolean)
   Dim ClientId As Long
   
   ClientId = SearchClient(NickName)
   
   If ClientId <> -1 And LCase$(TypeName$(Client(ClientId).cpTransferForm)) <> "nothing" Then
      Call Client(ClientId).cpTransferForm.QuitTransfer(bolAbbort, bolFaild)
   
   Else
      'client not found'
      MsgBox "Fehler bei Dateitransfer mit ''" & Client(ClientId).cpUsername & "''.", vbOKOnly + vbCritical, "Fehler"
   
   End If

End Sub

Public Sub DoLoggedInCheck(Optional OnlyReset As Boolean = False)
   Dim I As Long
   
   If Not IsClientListDim(Client) Then Exit Sub
   
   For I = 0 To UBound(Client)
      If I > UBound(Client) Then Exit For
      If OnlyReset Then
         Client(I).cpStillLoggedIn = False
      Else
         If Not Client(I).cpStillLoggedIn Then
            If RemoveClient(, I) Then
               I = I - 1
            End If
            If I < 0 Then Exit For
         End If
      End If
   Next I

End Sub

'Public Function CurrentFileTransferClient() As Long
'   Dim i As Long
'
'   CurrentFileTransferClient = -1
'   If Not IsClientListDim(Client) Then Exit Function
'
'   For i = 0 To UBound(Client)
'      If IsFormLoaded(Client(i).cpTransferForm) Then
'         If Client(i).cpTransferForm.IsTransferRunning Then
'            CurrentFileTransferClient = i
'            Exit Function
'         End If
'      End If
'   Next i
'
'End Function

Public Function SetClientRelationship(NickName As String, iRelationship As ClientRelationship) As Long
   Dim tmpFriendList As String, tmpUnwantedList As String
   Dim ClientId As Long
      
   ClientId = SearchClient(NickName)
   
   If ClientId <> -1 Then
      'load relationship lists'
      tmpFriendList = modSettings.GetSetting("ClientRelationship", "Friends")
      tmpUnwantedList = modSettings.GetSetting("ClientRelationship", "Unwanted")
      
      'remove client'
      tmpFriendList = Replace(tmpFriendList, Client(ClientId).cpUsername, "", , , vbTextCompare)
      tmpUnwantedList = Replace(tmpUnwantedList, Client(ClientId).cpUsername, "", , , vbTextCompare)
      
      'add client to list'
      Select Case iRelationship
         Case crFriend
            tmpFriendList = tmpFriendList & "," & Client(ClientId).cpUsername
         Case crUnwanted
            tmpUnwantedList = tmpUnwantedList & "," & Client(ClientId).cpUsername
         Case crNone
            'NOP'
      End Select
      
      Client(ClientId).cpRelationship = iRelationship
      
      If Client(ClientId).cpOnlineState = cosOffline And iRelationship = crNone Then
         RaiseEvent RemoveClient(Client(ClientId).cpUsername, Client(ClientId).cpRelationship)
      Else
         RaiseEvent DataChange(Client(ClientId).cpUsername, Client(ClientId).cpRemoteIP, Client(ClientId).cpOnlineState, Client(ClientId).cpRelationship)
      End If
      
      tmpFriendList = Replace(tmpFriendList, ",,", ",")
      If Left$(tmpFriendList, 1) = "," Then tmpFriendList = Right$(tmpFriendList, Len(tmpFriendList) - 1)
      If Right$(tmpFriendList, 1) = "," Then tmpFriendList = Left$(tmpFriendList, Len(tmpFriendList) - 1)
      
      tmpUnwantedList = Replace(tmpUnwantedList, ",,", ",")
      If Left$(tmpUnwantedList, 1) = "," Then tmpUnwantedList = Right$(tmpUnwantedList, Len(tmpUnwantedList) - 1)
      If Right$(tmpUnwantedList, 1) = "," Then tmpUnwantedList = Left$(tmpUnwantedList, Len(tmpUnwantedList) - 1)
      
      'save relationship lists'
      Call modSettings.WriteSetting("ClientRelationship", "Friends", tmpFriendList)
      Call modSettings.WriteSetting("ClientRelationship", "Unwanted", tmpUnwantedList)
   
      tmpFriendList = vbNullString
      tmpUnwantedList = vbNullString
   
      SetClientRelationship = 0
   
   Else
      'client not found'
      SetClientRelationship = -1
   
   End If

End Function

Public Sub LoadClientsLists()
   Dim tmpFriendList() As String, tmpUnwantedList() As String
   Dim I As Long
   
   'load relationship lists'
   tmpFriendList = Split(modSettings.GetSetting("ClientRelationship", "Friends"), ",")
   tmpUnwantedList = Split(modSettings.GetSetting("ClientRelationship", "Unwanted"), ",")
   
   For I = 0 To UBound(tmpFriendList)
      Call SetClient(tmpFriendList(I), , cosOffline)
   Next I
   
   For I = 0 To UBound(tmpUnwantedList)
      Call SetClient(tmpUnwantedList(I), , cosOffline)
   Next I
   
End Sub

Public Sub UpdateClientRelationship(Optional NickName As String, Optional Index As Long = -1)
   Dim tmpFriendList As String, tmpUnwantedList As String
   Dim ClientId As Long
   
   If Index <> -1 Then
      ClientId = Index
   Else
      ClientId = SearchClient(NickName)
   End If
   
   If ClientId <> -1 Then
      'load relationship lists'
      tmpFriendList = modSettings.GetSetting("ClientRelationship", "Friends")
      tmpUnwantedList = modSettings.GetSetting("ClientRelationship", "Unwanted")

      If InStr(1, "," & tmpFriendList & ",", "," & Client(ClientId).cpUsername & ",", vbTextCompare) > 0 Then
         Client(ClientId).cpRelationship = crFriend
      ElseIf InStr(1, "," & tmpUnwantedList & ",", "," & Client(ClientId).cpUsername & ",", vbTextCompare) > 0 Then
         Client(ClientId).cpRelationship = crUnwanted
      Else
         Client(ClientId).cpRelationship = crNone
      End If

   End If

End Sub

Public Function GetClientRelationship(NickName As String, Optional NoInListSearch As Boolean = False) As ClientRelationship
   Dim tmpFriendList As String, tmpUnwantedList As String
   Dim ClientId As Long
   
   If Not NoInListSearch Then
      ClientId = SearchClient(NickName)
      If ClientId <> -1 Then
         GetClientRelationship = Client(ClientId).cpRelationship
      Else
         GetClientRelationship = crNone
      End If

   Else
      'load relationship lists'
      tmpFriendList = modSettings.GetSetting("ClientRelationship", "Friends")
      tmpUnwantedList = modSettings.GetSetting("ClientRelationship", "Unwanted")
   
      If InStr(1, "," & tmpFriendList & ",", "," & NickName & ",", vbTextCompare) > 0 Then
         GetClientRelationship = crFriend
      ElseIf InStr(1, "," & tmpUnwantedList & ",", "," & NickName & ",", vbTextCompare) > 0 Then
         GetClientRelationship = crUnwanted
      Else
         GetClientRelationship = crNone
      End If
   
   End If

End Function

Private Sub SendOnlineStateNotification(NickName As String)
   Dim ClientId As Long
   
   ClientId = SearchClient(NickName)
   
   If ClientId <> -1 Then
      'send state of this client to each other client'
      Call BroadcastConnectedClients( _
          Encoder.GetCommandLine("USER", _
              Client(ClientId).cpLAN_IP, _
              CStr(Client(ClientId).cpOnlineState), _
              Client(ClientId).cpRemoteIP, _
              Client(ClientId).cpUsername _
          ) _
      )
   
   Else
      'client not found'
      'NOP'
      
   End If

End Sub

Private Sub SendMyOnlineState()
   Dim OnlineClients() As String
   Dim ClientNumber As Long
   Dim rndClientId As Long
   Dim ClientId As Long
   
   OnlineClients = GetAllOnlineClients
   If UBound(OnlineClients) = 1 And OnlineClients(0) = "" Then Exit Sub
   
   ClientNumber = CLng(((UBound(OnlineClients) + 1) / 100) * StateNotifyClients)
   If ClientNumber < StateNotifyMin Then ClientNumber = StateNotifyMin
   If ClientNumber > StateNotifyMax Then ClientNumber = StateNotifyMax
   If ClientNumber > UBound(OnlineClients) + 1 Then ClientNumber = UBound(OnlineClients) + 1

   'send data to random clients'
   Do
      Randomize Timer
      rndClientId = CLng(Rnd * UBound(OnlineClients))

      ClientId = SearchClient(OnlineClients(rndClientId))

      If ClientId <> -1 Then
         OnlineClients(rndClientId) = ""
         ClientNumber = ClientNumber - 1

         'send data'
         Call MyConnection.clsWinSock_SendDatas( _
            Encoder.GetCommandLine("USER", _
               modClient.LocalUser.cpLAN_IP, _
               modClient.LocalUser.cpOnlineState, _
               modClient.LocalUser.cpRemoteIP, _
               modClient.LocalUser.cpUsername _
            ), _
            GetOptimallyIP(Client(ClientId).cpUsername, Client(ClientId).cpRemoteIP), _
            Client(ClientId).cpUsername, _
         , , , , True)

         DoEvents
         Call Sleep(1)

      End If

   Loop Until ClientNumber = 0

End Sub

Private Function GetAllOnlineClients() As String()
   Dim I As Long
   Dim tmpClientList As String
   
'   Erase GetAllOnlineClients
   
   If Not IsClientListDim(Client) Then Exit Function
   
   For I = 0 To UBound(Client)
      If Client(I).cpOnlineState <> cosOffline And Client(I).cpOnlineState <> cosUnknown And Client(I).cpUsername <> "" Then
         tmpClientList = tmpClientList & Client(I).cpUsername & "|"
      End If
   Next I
   
   If Right$(tmpClientList, 1) = "|" Then tmpClientList = Left$(tmpClientList, Len(tmpClientList) - 1)
   
   If tmpClientList = "" Then tmpClientList = "|"
   
   GetAllOnlineClients = Split(tmpClientList, "|")
   
End Function

Public Sub RequestOnlineStateMessage(NickName As String)
   Dim ClientId As Long
   
   ClientId = SearchClient(NickName)
   
   If ClientId <> -1 Then
      'send state message request'
      
      Call MyConnection.clsWinSock_SendDatas( _
         Encoder.GetCommandLine("STATE_MESSAGE_REQUEST", _
            modClient.LocalUser.cpRemoteIP, _
            modClient.LocalUser.cpUsername _
         ), _
         GetOptimallyIP(Client(ClientId).cpUsername, Client(ClientId).cpRemoteIP), _
         Client(ClientId).cpUsername _
      )

   End If

End Sub

Private Function IsClientListDim(iArray() As ClientProperties) As Boolean
   On Local Error GoTo ErrorHandler
   Dim res As Long
   IsClientListDim = True
   res = UBound(iArray)
   Exit Function

ErrorHandler:
   IsClientListDim = False
   
End Function

