VERSION 5.00
Begin VB.UserControl ProgressBar 
   Alignable       =   -1  'True
   BackColor       =   &H00000000&
   CanGetFocus     =   0   'False
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4215
   PropertyPages   =   "Progressbar.ctx":0000
   ScaleHeight     =   285
   ScaleWidth      =   4215
   ToolboxBitmap   =   "Progressbar.ctx":0048
End
Attribute VB_Name = "ProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'################################################################################
' Modul           : ProgressBar
' Beschreibung    : CommonControls Replacement
'                   mit Windows XP Style Untersttzung
'
' Erstellt von    : Peter Krner, Christoph von Wittich
' Letztes Update  : Freitag, 25. Juni 2004
'
' Copyright (C) 2004 bei Peter Krner und Christoph von Wittich
' Kontakt: Christoph@ActiveVB.de

Private Const PROGRESS_CLASS As String = "msctls_progress32"

Private Const WM_USER As Long = &H400

Private Const CCM_FIRST As Long = &H2000
Private Const CCM_SETBKCOLOR As Long = (CCM_FIRST + 1)

Private Const PBM_SETBARCOLOR As Long = (WM_USER + 9)
Private Const PBM_SETBKCOLOR As Long = CCM_SETBKCOLOR
Private Const PBM_SETRANGE As Long = (WM_USER + 1)
Private Const PBM_SETRANGE32 As Long = (WM_USER + 6)
Private Const PBM_SETMARQUEE  As Long = 1034
Private Const PBM_SETPOS As Long = (WM_USER + 2)

Private Const VK_CONTROL As Long = &H11
Private Const VK_MENU As Long = &H12
Private Const VK_SHIFT As Long = &H10
Private Const VK_LBUTTON As Long = &H1
Private Const VK_MBUTTON As Long = &H4
Private Const VK_RBUTTON As Long = &H2
Private Const VK_XBUTTON1 As Long = &H5
Private Const VK_XBUTTON2 As Long = &H6

Private Const TME_LEAVE As Long = &H2
Private Const TME_HOVER As Long = &H1

Private Const WS_CHILD As Long = &H40000000
Private Const WS_CLIPSIBLINGS As Long = &H4000000
Private Const WS_OVERLAPPED As Long = &H0&
Private Const WS_VISIBLE As Long = &H10000000
Private Const WS_DLGFRAME As Long = &H400000

Private Const PBS_VERTICAL As Long = &H4
Private Const PBS_SMOOTH As Long = &H1
Private Const PBS_MARQUEE   As Long = &H8

Private Const ICC_BAR_CLASSES As Long = &H4
Private Const ICC_TREEVIEW_CLASSES As Long = &H2

Private Const GCL_STYLE As Long = -26
Private Const CS_DBLCLKS As Long = &H8

Private Const XBUTTON1 As Long = &H1
Private Const XBUTTON2 As Long = &H2

Private Const WHEEL_DELTA As Long = 120

Public Enum ScrollingConstants
    ccScrollingStandard = 0
    ccScrollingSmooth = 1
End Enum

Private Type InitCommonControlsEx
    dwSize As Long 'size of this structure
    dwICC As Long 'flags indicating which classes to be initialized
End Type

Private Type tPOINT
    X As Long
    Y As Long
End Type

Private Type tRECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type tTRACKMOUSEEVENT
    cbSize As Long
    dwFlags As Long
    hwndTrack As Long
    dwHoverTime As Long
 End Type

'comctl32.dll
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (ByRef TLPINITCOMMONCONTROLSEX As InitCommonControlsEx) As Long

'user32.dll
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function TrackMouseEvent Lib "user32.dll" (ByRef lpEventTrack As tTRACKMOUSEEVENT) As Long
Private Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Integer
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function EnableWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lptRECT As tRECT) As Long
Private Declare Function CreateWindowExUnicode Lib "user32.dll" Alias "CreateWindowExW" (ByVal dwExStyle As Long, ByVal lpClassName As Long, ByVal lpWindowName As Long, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, ByVal lpParam As Long) As Long
Private Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, ByVal lpParam As Long) As Long
Private Declare Function GetClassLongUnicode Lib "user32.dll" Alias "GetClassLongW" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetClassLong Lib "user32.dll" Alias "GetClassLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetClassLong Lib "user32.dll" Alias "SetClassLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetClassLongUnicode Lib "user32.dll" Alias "SetClassLongW" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function MoveWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As tPOINT) As Long
Private Declare Function WindowFromPoint Lib "user32.dll" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As tPOINT) As Long

'Property-Default-Values
Private Const def_Orientation As Long = ccOrientationHorizontal
Private Const def_Scrolling As Long = ccScrollingStandard
Private Const def_Min As Long = 0
Private Const def_Max As Long = 100
Private Const def_Value As Long = 50
Private Const def_Marquee As Boolean = False
Private Const def_BackColor As Long = vbButtonFace
Private Const def_BarColor As Long = vbHighlight
Private Const def_MarqueeSpeed As Long = 50
Private Const def_MarqueeRunning As Boolean = True
Private Const def_Appearance As Long = cc3D
Private Const def_BorderStyle As Long = ccNone
Private Const def_Enabled As Boolean = True
Private Const def_UseVisualStyles As Boolean = True
Private Const def_MousePointer As Long = vbArrow
Private Const def_OLEDropMode As Long = vbOLEDropNone

' -> Local Variables
Private m_hWnd As Long
Private m_Orientation As Long
Private m_Scrolling As ScrollingConstants
Private m_Min As Long
Private m_Max As Long
Private m_Value As Long
Private m_Marquee As Boolean
Private m_BackColor As Long
Private m_BarColor As Long
Private m_MarqueeSpeed As Long
Private m_MarqueeRunning As Boolean
Private m_Appearance As AppearanceConstants
Private m_BorderStyle As BorderStyleConstants
Private m_Enabled As Boolean
Private m_UseVisualStyles As Boolean
Private m_MousePointer As MousePointerConstants
Private m_MouseIcon  As IPictureDisp
Private m_OLEDropMode As Long

' -> Events
Public Event Click()
Public Event DblClick()
Public Event ClickEx(Button As MouseButtonConstants, Shift As ShiftConstants, X As Single, Y As Single)
Public Event DblClickEx(Button As MouseButtonConstants, Shift As ShiftConstants, X As Single, Y As Single)
Public Event MouseDown(Button As MouseButtonConstants, Shift As ShiftConstants, X As Single, Y As Single)
Public Event MouseUp(Button As MouseButtonConstants, Shift As ShiftConstants, X As Single, Y As Single)
Public Event MouseMove(Button As MouseButtonConstants, Shift As ShiftConstants, X As Single, Y As Single) ' !! Global Buttoncode
Public Event MouseLeave()
Public Event MouseEnter()
Public Event MouseWheel(Button As MouseButtonConstants, Shift As ShiftConstants, X As Single, Y As Single, Delta As Long) ' !! Global Buttoncode

' -> Variables for internal use
Private WithEvents oControlHook As clsHook
Attribute oControlHook.VB_VarHelpID = -1
Private WithEvents oParentHook As clsHook
Attribute oParentHook.VB_VarHelpID = -1

Private m_MouseOver As Boolean
Private boClickDown As Boolean
Private lFormHandle As Long

' --> Public Procedures
' -> Properties
Public Property Get hwnd() As Long
    hwnd = m_hWnd
End Property
Public Property Get hdc() As Long
    hdc = GetDC(m_hWnd)
End Property

'FIXIT: 'Container' mit einem Datentyp mit frher Bindung deklarieren                      FixIT90210ae-R1672-R1B8ZE
Public Property Get Container() As Object
    'TODO: Check if (in this Case) Parent is the same as Container
    Set Container = UserControl.Parent
End Property

Public Property Get Orientation() As OrientationConstants
    Orientation = m_Orientation
End Property

Public Property Let Orientation(ByVal NewValue As OrientationConstants)
    m_Orientation = NewValue
    Call PropertyChanged("Orientation")
    Call UpdateSettings(True)
End Property

Public Property Get Scrolling() As ScrollingConstants
    Scrolling = m_Scrolling
End Property
Public Property Let Scrolling(ByVal NewValue As ScrollingConstants)
    m_Scrolling = NewValue
    Call PropertyChanged("Scrolling")
    Call UpdateSettings(True)
End Property
Public Property Get Min() As Long
    Min = m_Min
End Property
Public Property Let Min(ByVal NewValue As Long)
    If NewValue >= m_Max Then Exit Property
    If m_Value < NewValue Then m_Value = NewValue
    m_Min = NewValue
    Call PropertyChanged("Min")
    Call UpdateSettings
End Property
Public Property Get Max() As Long
    Max = m_Max
End Property
Public Property Let Max(ByVal NewValue As Long)
    If NewValue <= m_Min Then Exit Property
    If m_Value > NewValue Then m_Value = NewValue
    m_Max = NewValue
    Call PropertyChanged("Max")
    Call UpdateSettings
End Property
Public Property Get Value() As Long
    Value = m_Value
End Property
Public Property Let Value(ByVal NewValue As Long)
    If (NewValue > m_Max) Or (NewValue < m_Min) Then Exit Property
    If Not m_MarqueeRunning Or Not m_Marquee Then
        m_Value = NewValue
        Call PropertyChanged("Value")
        Call UpdateSettings
    End If
End Property
Public Property Get Marquee() As Boolean
    Marquee = m_Marquee
End Property
Public Property Let Marquee(ByVal NewValue As Boolean)
    m_Marquee = NewValue
    Call PropertyChanged("Marquee")
    Call UpdateSettings(True)
End Property
Public Property Get BackColor() As OLE_COLOR
    BackColor = m_BackColor
End Property
Public Property Let BackColor(ByVal NewValue As OLE_COLOR)
    m_BackColor = NewValue
    Call PropertyChanged("BackColor")
    Call UpdateSettings
End Property
Public Property Get BarColor() As OLE_COLOR
    BarColor = m_BarColor
End Property
Public Property Let BarColor(ByVal NewValue As OLE_COLOR)
    m_BarColor = NewValue
    Call PropertyChanged("BarColor")
    Call UpdateSettings
End Property
Public Property Get MarqueeSpeed() As Long
    MarqueeSpeed = m_MarqueeSpeed
End Property
Public Property Let MarqueeSpeed(ByVal NewValue As Long)
    If NewValue <= 0 Then Exit Property
    m_MarqueeSpeed = NewValue
    Call PropertyChanged("MarqueeSpeed")
    Call UpdateSettings
End Property
Public Property Get MarqueeRunning() As Boolean
    MarqueeRunning = m_MarqueeRunning
End Property
Public Property Let MarqueeRunning(ByVal NewValue As Boolean)
    m_MarqueeRunning = NewValue
    Call PropertyChanged("MarqueeRunning")
    Call UpdateSettings
End Property
Public Property Get Appearance() As AppearanceConstants
    Appearance = m_Appearance
End Property
Public Property Let Appearance(ByVal NewValue As AppearanceConstants)
    m_Appearance = NewValue
    Call PropertyChanged("Appearance")
    Call UpdateSettings(True)
End Property
Public Property Get BorderStyle() As BorderStyleConstants
    BorderStyle = m_BorderStyle
End Property
Public Property Let BorderStyle(ByVal NewValue As BorderStyleConstants)
    m_BorderStyle = NewValue
    Call PropertyChanged("BorderStyle")
    Call UpdateSettings(True)
End Property
Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property
Public Property Let Enabled(ByVal NewValue As Boolean)
    m_Enabled = NewValue
    Call PropertyChanged("Enabled")
    Call UpdateSettings
End Property
Public Property Get UseVisualStyles() As Boolean
    UseVisualStyles = m_UseVisualStyles
End Property
Public Property Let UseVisualStyles(ByVal NewValue As Boolean)
    m_UseVisualStyles = NewValue
    Call PropertyChanged("UseVisualStyles")
    Call UpdateSettings
End Property
Public Property Get MousePointer() As MousePointerConstants
    MousePointer = m_MousePointer
End Property
Public Property Let MousePointer(ByVal NewValue As MousePointerConstants)
    m_MousePointer = NewValue
    Call PropertyChanged("MousePointer")
    Call UpdateSettings(False)
End Property

Public Property Get OLEDropMode() As OLEDropConstants
    OLEDropMode = m_OLEDropMode
End Property

Public Property Let OLEDropMode(ByVal NewValue As OLEDropConstants)
    m_OLEDropMode = NewValue
    Call PropertyChanged("OLEDropMode")
    Call UpdateSettings(False)
End Property

Public Property Get MouseIcon() As IPictureDisp
    Set MouseIcon = m_MouseIcon
End Property
Public Property Set MouseIcon(NewValue As IPictureDisp)
    Set m_MouseIcon = NewValue
    Call PropertyChanged("MouseIcon")
    Call UpdateSettings(False)
End Property

' -> Procedures
Private Sub GetKeyCodes(ShiftCode As ShiftConstants, ButtonCode As MouseButtonConstants)
    ShiftCode = 0
    ButtonCode = 0
    If GetKeyState(VK_CONTROL) < 0 Then ShiftCode = ShiftCode Or ccCtrl
    If GetKeyState(VK_MENU) < 0 Then ShiftCode = ShiftCode Or ccAlt
    If GetKeyState(VK_SHIFT) < 0 Then ShiftCode = ShiftCode Or ccShift
    If GetKeyState(VK_LBUTTON) < 0 Then ButtonCode = ButtonCode Or ccLeft
    If GetKeyState(VK_MBUTTON) < 0 Then ButtonCode = ButtonCode Or ccMiddle
    If GetKeyState(VK_RBUTTON) < 0 Then ButtonCode = ButtonCode Or ccRight
    If GetKeyState(VK_XBUTTON1) < 0 Then ButtonCode = ButtonCode Or ccXButton1
    If GetKeyState(VK_XBUTTON2) < 0 Then ButtonCode = ButtonCode Or ccXButton2
End Sub

' --> Private Procedures
Private Sub UpdateSettings(Optional boReCreate As Boolean = False)
    Dim rcClient As tRECT
    Dim boUserMode As Boolean
    
    'Falls UserControl.Ambient.UserMode noch nicht verfgbar
    ' ist befinden wir uns 100%ig in der IDE.
    On Error GoTo NotUserMode
    If UserControl.Ambient.UserMode Then
        boUserMode = True
    End If
NotUserMode:
    On Error GoTo 0
    
    If m_hWnd <> 0 And boReCreate Then
        Call oControlHook.DestroyHook
        Call DestroyWindow(m_hWnd)
        m_hWnd = 0
    End If
    
    If m_hWnd = 0 Then
        Call GetClientRect(UserControl.hwnd, rcClient)
        
        If IsUnicodeSupported Then
            m_hWnd = CreateWindowExUnicode( _
                0&, _
                StrPtr(PROGRESS_CLASS), _
                StrPtr(UserControl.Name), _
                    WS_CHILD Or _
                    WS_VISIBLE Or _
                    WS_CLIPSIBLINGS Or _
                    WS_OVERLAPPED Or _
                    IIf((m_BorderStyle = ccFixedSingle) And Not (m_UseVisualStyles And ThemeActive), WS_DLGFRAME, &H0) Or _
                    IIf((m_Orientation = 1) And CheckVer("4.7"), PBS_VERTICAL, 0) Or _
                    IIf(m_Scrolling And CheckVer("4.7"), PBS_SMOOTH, 0) Or _
                    IIf(m_Marquee And m_MarqueeRunning And boUserMode And CheckVer("6.0"), PBS_MARQUEE, 0), _
                0, 0, _
                rcClient.Right, _
                rcClient.Bottom, _
                UserControl.hwnd, _
                0&, _
                App.hInstance, _
                0& _
            )
        Else
            m_hWnd = CreateWindowEx( _
                0&, _
                PROGRESS_CLASS, _
                UserControl.Name, _
                    WS_CHILD Or _
                    WS_VISIBLE Or _
                    WS_CLIPSIBLINGS Or _
                    WS_OVERLAPPED Or _
                    IIf((m_BorderStyle = ccFixedSingle) And Not (m_UseVisualStyles And ThemeActive), WS_DLGFRAME, &H0) Or _
                    IIf((m_Orientation = ccOrientationVertical) And CheckVer("4.7"), PBS_VERTICAL, 0) Or _
                    IIf(m_Scrolling And CheckVer("4.7"), PBS_SMOOTH, 0) Or _
                    IIf(m_Marquee And m_MarqueeRunning And boUserMode And CheckVer("6.0"), PBS_MARQUEE, 0), _
                0, 0, _
                rcClient.Right, _
                rcClient.Bottom, _
                UserControl.hwnd, _
                0&, _
                App.hInstance, _
                0& _
            )
        End If
        
        If m_hWnd = 0 Then Exit Sub
        
        If IsUnicodeSupported Then
            Call SetClassLongUnicode(m_hWnd, GCL_STYLE, GetClassLongUnicode(m_hWnd, GCL_STYLE) Or CS_DBLCLKS)
        Else
            Call SetClassLong(m_hWnd, GCL_STYLE, GetClassLong(m_hWnd, GCL_STYLE) Or CS_DBLCLKS)
        End If
        
        ' Subclassing in der IDE unterbinden.
        If boUserMode Then
            Call oControlHook.CreateHook(m_hWnd)
            Call oControlHook.AddMessage(WM_LBUTTONDOWN)
            Call oControlHook.AddMessage(WM_LBUTTONUP)
            Call oControlHook.AddMessage(WM_LBUTTONDBLCLK)
            Call oControlHook.AddMessage(WM_RBUTTONDOWN)
            Call oControlHook.AddMessage(WM_RBUTTONUP)
            Call oControlHook.AddMessage(WM_RBUTTONDBLCLK)
            Call oControlHook.AddMessage(WM_MBUTTONDOWN)
            Call oControlHook.AddMessage(WM_MBUTTONUP)
            Call oControlHook.AddMessage(WM_MBUTTONDBLCLK)
            Call oControlHook.AddMessage(WM_XBUTTONDOWN)
            Call oControlHook.AddMessage(WM_XBUTTONUP)
            Call oControlHook.AddMessage(WM_XBUTTONDBLCLK)
            Call oControlHook.AddMessage(WM_MOUSEMOVE)
            Call oControlHook.AddMessage(WM_MOUSEHOVER)
            Call oControlHook.AddMessage(WM_MOUSELEAVE)
        End If
    End If
    
    'Themes An/Ausschalten
    Call SetTheme(m_hWnd, m_UseVisualStyles)
    
    ' Ich wei nicht wie die PGB reagiert wenn
    ' man im Marquee-Style PBM_SETRANGE oder
    ' PBM_SETRANGE32 sendet, daher lass ich das lieber...
    If m_Marquee And CheckVer("6.0") Then
        ' Diese Ausnahme ist aufgrund eines Bugs ntig, der auftritt wenn man
        ' bei PBM_SETMARQUEE wParam auf 0 setzt und die Bar dann zu einem
        ' Redraw zwingt.
        If m_MarqueeRunning And boUserMode Then
            Call SendMessage(m_hWnd, PBM_SETMARQUEE, ByVal 1, ByVal m_MarqueeSpeed)
        Else
            Call SendMessage(m_hWnd, PBM_SETPOS, m_Min, ByVal 0&)
        End If
    Else
        If CheckVer("4.7") Then
            Call SendMessage(m_hWnd, PBM_SETBKCOLOR, 0&, ByVal TranslateColor(m_BackColor))
            Call SendMessage(m_hWnd, PBM_SETBARCOLOR, 0&, ByVal TranslateColor(m_BarColor))
            Call SendMessage(m_hWnd, PBM_SETRANGE32, m_Min, ByVal m_Max)
        Else
            Call SendMessage(m_hWnd, PBM_SETRANGE, ByVal 0&, ByVal MAKELONG(m_Min, m_Max))
        End If
        Call SendMessage(m_hWnd, PBM_SETPOS, m_Value, ByVal 0&)
    End If
    
    Call EnableWindow(m_hWnd, Abs(CLng(m_Enabled)))
    
    UserControl.MousePointer = m_MousePointer
    Set UserControl.MouseIcon = m_MouseIcon
    UserControl.OLEDropMode = m_OLEDropMode
    
End Sub

Private Sub oParentHook_Before(uMsg As WM_CONST, wParam As Long, lParam As Long, lngRetVal As Long)
    Select Case uMsg
        Case WM_MOUSEWHEEL
            Call oControlHook.RaiseBefore(uMsg, wParam, lParam)
    End Select
End Sub

Private Sub UserControl_Initialize()
    Dim InitCC As InitCommonControlsEx
    
    InitCC.dwICC = ICC_BAR_CLASSES Or ICC_TREEVIEW_CLASSES
    InitCC.dwSize = Len(InitCC)
    InitCommonControlsEx InitCC
    
    Set oControlHook = New clsHook
    Set oParentHook = New clsHook

    Call SetDefaultProperties
    Call UpdateSettings(True)
End Sub

Private Sub UserControl_Terminate()
    Set oControlHook = Nothing
    Set oParentHook = Nothing
    DoEvents
    If m_hWnd <> 0 Then
        DestroyWindow m_hWnd
    End If
End Sub

Private Sub UserControl_Resize()
    Dim uRECT As tRECT
    Call GetClientRect(UserControl.hwnd, uRECT)
    Call MoveWindow(m_hWnd, uRECT.Left, uRECT.Top, uRECT.Right - uRECT.Left, uRECT.Bottom - uRECT.Top, 1)
End Sub

Private Sub UserControl_Show()
    If lFormHandle <> 0 Or Not UserControl.Ambient.UserMode Then Exit Sub
    lFormHandle = GetTopParent(UserControl.hwnd)
    Call oParentHook.CreateHook(lFormHandle)
    Call oParentHook.AddMessage(WM_MOUSEWHEEL)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Orientation = PropBag.ReadProperty("Orientation", def_Orientation)
    m_Scrolling = PropBag.ReadProperty("Scrolling", def_Scrolling)
    m_Min = PropBag.ReadProperty("Min", def_Min)
    m_Max = PropBag.ReadProperty("Max", def_Max)
    m_Value = PropBag.ReadProperty("Value", def_Value)
    m_Marquee = PropBag.ReadProperty("Marquee", def_Marquee)
    m_BackColor = PropBag.ReadProperty("BackColor", def_BackColor)
    m_BarColor = PropBag.ReadProperty("BarColor", def_BarColor)
    m_MarqueeSpeed = PropBag.ReadProperty("MarqueeSpeed", def_MarqueeSpeed)
    m_MarqueeRunning = PropBag.ReadProperty("MarqueeRunning", def_MarqueeRunning)
    m_Appearance = PropBag.ReadProperty("Appearance", def_Appearance)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", def_BorderStyle)
    m_Enabled = PropBag.ReadProperty("Enabled", def_Enabled)
    m_UseVisualStyles = PropBag.ReadProperty("UseVisualStyles", def_UseVisualStyles)
    m_MousePointer = PropBag.ReadProperty("MousePointer", def_MousePointer)
    m_OLEDropMode = PropBag.ReadProperty("OLEDropMode", def_OLEDropMode)
    Set m_MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    Call UpdateSettings(True)
End Sub

Private Sub SetDefaultProperties()
    m_Orientation = def_Orientation
    m_Scrolling = def_Scrolling
    m_Min = def_Min
    m_Max = def_Max
    m_Value = def_Value
    m_Marquee = def_Marquee
    m_BackColor = def_BackColor
    m_BarColor = def_BarColor
    m_MarqueeSpeed = def_MarqueeSpeed
    m_MarqueeRunning = def_MarqueeRunning
    m_Appearance = def_Appearance
    m_BorderStyle = def_BorderStyle
    m_Enabled = def_Enabled
    m_UseVisualStyles = def_UseVisualStyles
    m_MousePointer = def_MousePointer
    m_OLEDropMode = def_OLEDropMode
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Orientation", m_Orientation, def_Orientation)
    Call PropBag.WriteProperty("Scrolling", m_Scrolling, def_Scrolling)
    Call PropBag.WriteProperty("Min", m_Min, def_Min)
    Call PropBag.WriteProperty("Max", m_Max, def_Max)
    Call PropBag.WriteProperty("Value", m_Value, def_Value)
    Call PropBag.WriteProperty("Marquee", m_Marquee, def_Marquee)
    Call PropBag.WriteProperty("BackColor", m_BackColor, def_BackColor)
    Call PropBag.WriteProperty("BarColor", m_BarColor, def_BarColor)
    Call PropBag.WriteProperty("MarqueeSpeed", m_MarqueeSpeed, def_MarqueeSpeed)
    Call PropBag.WriteProperty("MarqueeRunning", m_MarqueeRunning, def_MarqueeRunning)
    Call PropBag.WriteProperty("Appearance", m_Appearance)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle)
    Call PropBag.WriteProperty("Enabled", m_Enabled)
    Call PropBag.WriteProperty("UseVisualStyles", m_UseVisualStyles)
    Call PropBag.WriteProperty("MousePointer", m_MousePointer, def_MousePointer)
    Call PropBag.WriteProperty("MouseIcon", m_MouseIcon)
    Call PropBag.WriteProperty("OLEDropMode", m_OLEDropMode)
End Sub

Private Sub oControlHook_Before(uMsg As WM_CONST, wParam As Long, lParam As Long, lngRetVal As Long)
    Dim lShiftCode As ShiftConstants
    Dim lButtonCode As MouseButtonConstants
    Dim lEventButton As MouseButtonConstants
    Dim uCursorPos As tPOINT
    Dim sngXTwp As Single
    Dim sngYTwp As Single
    Dim iMouseWheelData As Integer
    Dim lDelta As Long
    Dim boHitTest As Boolean
    Dim iXBut As Integer
    
    Call GetKeyCodes(lShiftCode, lButtonCode)
    
    Call GetCursorPos(uCursorPos)
    boHitTest = WindowFromPoint(uCursorPos.X, uCursorPos.Y) = m_hWnd
    Call ScreenToClient(m_hWnd, uCursorPos)
    sngXTwp = UserControl.ScaleX(uCursorPos.X, vbPixels, vbTwips)
    sngYTwp = UserControl.ScaleY(uCursorPos.Y, vbPixels, vbTwips)
    
    Select Case uMsg
        Case WM_LBUTTONDOWN, WM_RBUTTONDOWN, WM_MBUTTONDOWN, WM_XBUTTONDOWN
            Select Case uMsg
                Case WM_LBUTTONDOWN: lEventButton = ccLeft
                Case WM_RBUTTONDOWN: lEventButton = ccRight
                Case WM_MBUTTONDOWN: lEventButton = ccMiddle
                Case WM_XBUTTONDOWN
                    Call SPLITLONG(iXBut, 0, wParam)
                    Select Case iXBut
                        Case XBUTTON1: lEventButton = ccXButton1
                        Case XBUTTON2: lEventButton = ccXButton2
                    End Select
            End Select
            RaiseEvent MouseDown(lEventButton, lShiftCode, sngXTwp, sngYTwp)
            boClickDown = True
            
            
        Case WM_LBUTTONUP, WM_RBUTTONUP, WM_MBUTTONUP, WM_XBUTTONUP
            Select Case uMsg
                Case WM_LBUTTONUP: lEventButton = ccLeft
                Case WM_RBUTTONUP: lEventButton = ccRight
                Case WM_MBUTTONUP: lEventButton = ccMiddle
                Case WM_XBUTTONUP
                    Call SPLITLONG(iXBut, 0, wParam)
                    Select Case iXBut
                        Case XBUTTON1: lEventButton = ccXButton1
                        Case XBUTTON2: lEventButton = ccXButton2
                    End Select
            End Select
            RaiseEvent MouseUp(lEventButton, lShiftCode, sngXTwp, sngYTwp)
            If boClickDown Then
                RaiseEvent Click
                RaiseEvent ClickEx(lEventButton, lShiftCode, sngXTwp, sngYTwp)
            End If
            
            
        Case WM_LBUTTONDBLCLK, WM_RBUTTONDBLCLK, WM_MBUTTONDBLCLK, WM_XBUTTONDBLCLK
            Select Case uMsg
                Case WM_LBUTTONDBLCLK: lEventButton = ccLeft
                Case WM_RBUTTONDBLCLK: lEventButton = ccRight
                Case WM_MBUTTONDBLCLK: lEventButton = ccMiddle
                Case WM_XBUTTONDBLCLK
                    Call SPLITLONG(iXBut, 0, wParam)
                    Select Case iXBut
                        Case XBUTTON1: lEventButton = ccXButton1
                        Case XBUTTON2: lEventButton = ccXButton2
                    End Select
            End Select
            RaiseEvent DblClick
            RaiseEvent DblClickEx(lEventButton, lShiftCode, sngXTwp, sngYTwp)
            
        Case WM_MOUSEMOVE
            Dim trk As tTRACKMOUSEEVENT
            trk.cbSize = Len(trk)
            trk.dwFlags = TME_LEAVE Or TME_HOVER
            trk.dwHoverTime = 10
            trk.hwndTrack = m_hWnd
            TrackMouseEvent trk
            RaiseEvent MouseMove(lButtonCode, lShiftCode, sngXTwp, sngYTwp)
            
        Case WM_MOUSEHOVER
            If Not m_MouseOver Then RaiseEvent MouseEnter
            m_MouseOver = True
            
        Case WM_MOUSELEAVE
            m_MouseOver = False
            RaiseEvent MouseLeave
            
        Case WM_MOUSEWHEEL
            Call SPLITLONG(0, iMouseWheelData, wParam)
            lDelta = iMouseWheelData / WHEEL_DELTA

            If boHitTest Then
                RaiseEvent MouseWheel(lButtonCode, lShiftCode, sngXTwp, sngYTwp, lDelta)
                uMsg = WM_NULL
            End If
    End Select
End Sub
