VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsStatusBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'################################################################################
' Modul        : clsStatusBar
' Beschreibung : ComClt32.ocx Replacement
'                fr die StatusBar
'
' Erstellt von : Christoph von Wittich
' Erstellt am  : Sonntag, 15. September 2002
'
' Copyright (C) 2002-2004 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Christoph@ActiveVB.de

Private Const CCM_FIRST As Long = &H2000
Private Const CCM_SETUNICODEFORMAT As Long = (CCM_FIRST + 5)

Private Const SBARS_SIZEGRIP As Long = &H100

Private Const WM_USER As Long = &H400

Private Const SB_SIMPLEID As Long = &HFF
Private Const SB_SETTEXTA As Long = (WM_USER + 1)
Private Const SB_SETPARTS As Long = (WM_USER + 4)
Private Const SB_GETPARTS As Long = (WM_USER + 6)
Private Const SB_SETMINHEIGHT As Long = (WM_USER + 8)
Private Const SB_SIMPLE As Long = (WM_USER + 9)
Private Const SB_SETTEXTW As Long = (WM_USER + 11)
Private Const SB_ISSIMPLE As Long = (WM_USER + 14)

Public Enum sbStyles
    sbNormal = 0
    sbSimple = 1
End Enum

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type InitCommonControlsEx
    dwSize As Long
    dwICC As Long
End Type

'COMCTL32
Private Declare Function CreateStatusWindow Lib "comctl32.dll" (ByVal Style As Long, ByVal lpszText As String, ByVal hWndParent As Long, ByVal wID As Long) As Long
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (ByRef TLPINITCOMMONCONTROLSEX As InitCommonControlsEx) As Long

'USER32
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessageByString Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function MoveWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As _
    Long

Private m_hWnd As Long
Private m_strText As String
Private m_lngPanels() As Long
Private m_lngOldWidth As Long

Public Property Get hwnd() As Long
    hwnd = m_hWnd
End Property

Private Sub Class_Initialize()
    Dim InitCC As InitCommonControlsEx
    
    InitCC.dwICC = &H4
    InitCC.dwSize = Len(InitCC)
    ReDim m_Panels(0)
    
    Call InitCommonControlsEx(InitCC)
End Sub

Public Sub Create(lngParentHandle As Long)
    m_hWnd = CreateStatusWindow(&H40000000 Or &H10000000 Or &H10& Or SBARS_SIZEGRIP, "", lngParentHandle, 200)
    Call SendMessage(m_hWnd, CCM_SETUNICODEFORMAT, Abs(CLng(IsUnicodeSupported)), 0)
End Sub

Public Sub Resize(hWndParent As Long)
    Dim udtStatusWindowRect As RECT, _
        udtParentWindowRect As RECT
    Call GetWindowRect(m_hWnd, udtStatusWindowRect)
    Call GetWindowRect(hWndParent, udtParentWindowRect)
    Call MoveWindow(m_hWnd, 0, 0, (udtParentWindowRect.Right - udtParentWindowRect.Left), (udtParentWindowRect.Bottom - udtParentWindowRect.Top) - (udtStatusWindowRect.Bottom - udtStatusWindowRect.Top), 1)
End Sub

Public Property Get Height() As Long
    Dim udtWindowRect As RECT
    Call GetWindowRect(m_hWnd, udtWindowRect)
    Height = (udtWindowRect.Bottom - udtWindowRect.Top) * m_lngTwipsPerPixelY
End Property

Public Property Let Text(strText As String)
    pSetText SB_SIMPLEID, strText
End Property

Private Sub pSetText(Panel As Long, strText As String)
    If (IsUnicodeSupported) Then
        Call SendMessage(m_hWnd, SB_SETTEXTW, Panel, ByVal StringPtr(strText))
    Else
        Call SendMessageByString(m_hWnd, SB_SETTEXTA, Panel, strText)
    End If
    m_strText = strText
End Sub

Public Property Get Text() As String
    Text = m_strText
End Property

Public Property Let Style(eStyle As sbStyles)
    Call SendMessage(m_hWnd, SB_SIMPLE, eStyle, 0)
End Property

Public Property Get Style() As sbStyles
    If (SendMessage(m_hWnd, SB_ISSIMPLE, 0, 0)) <> 0 Then
        Style = sbNormal
    Else
        Style = sbSimple
    End If
End Property

Public Property Let PanelWidth(Panel As Long, Width As Long)
    If ((Width < 0) Or (Width > 255)) Then
        Width = -1
    End If
    If (Panel >= PanelCount) Then
        ReDim Preserve m_lngPanels(Panel - 1)
        If (Width = -1) Then m_lngOldWidth = 0
        m_lngPanels(Panel - 1) = m_lngOldWidth + Width
        m_lngOldWidth = Width
    End If
    Call SendMessage(m_hWnd, SB_SETPARTS, Panel, m_lngPanels(0))
End Property

Public Property Let PanelText(Panel As Long, Text As String)
    Call pSetText(Panel - 1, Text)
End Property

Public Property Let MinHeight(Height As Long)
    Call SendMessage(m_hWnd, SB_SETMINHEIGHT, Height, 0)
End Property

Public Property Get PanelCount() As Long
    PanelCount = SendMessage(m_hWnd, SB_GETPARTS, 0, 0)
End Property

Private Sub Class_Terminate()
    If (m_hWnd <> 0) Then
        Call DestroyWindow(m_hWnd)
    End If
End Sub


