VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTabStrip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'################################################################################
' Modul        : clsTabStrip
' Beschreibung : ComClt32.ocx Replacement
'                fr das TabStrip-Control
'
' Erstellt von : Christoph von Wittich
' Erstellt am  : Sonntag, 16. September 2002
' Gendert am  : Sonntag, 23. Januar 2004
'
' Copyright (C) 2002-2004 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Christoph@ActiveVB.de


'--------------------------------------------------------------------------------------------------
' Konstanten
'--------------------------------------------------------------------------------------------------
Private Const LOGPIXELSY As Long = 90

'CommonControls Messages
Private Const CCM_FIRST As Long = &H2000
Private Const CCM_SETUNICODEFORMAT As Long = (CCM_FIRST + 5)

'Messages
Private Const TCM_FIRST As Long = &H1300
Private Const TCM_GETITEMCOUNT As Long = (TCM_FIRST + 4)
Private Const TCM_GETCURSEL As Long = (TCM_FIRST + 11)
Private Const TCM_INSERTITEMA As Long = (TCM_FIRST + 7)
Private Const TCM_INSERTITEMW As Long = (TCM_FIRST + 62)

'Notifications
Private Const TCN_FIRST As Long = -550
Private Const TCN_SELCHANGE As Long = (TCN_FIRST - 1)

'Window Messages
Private Const WM_NOTIFY  As Long = &H4E
Private Const WM_PAINT As Long = &HF
Private Const WM_SETFONT As Long = &H30

'--------------------------------------------------------------------------------------------------
' Typen
'--------------------------------------------------------------------------------------------------
Private Type InitCommonControlsEx
    dwSize As Long 'size of this structure
    dwICC As Long 'flags indicating which classes to be initialized
End Type

Private Type NMHDR
    hwndFrom As Long
    idFrom As Long
    Code As Long
End Type

Private Type TCITEM
    mask As Long
    dwState As Long
    dwStateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    lParam As Long
End Type

'--------------------------------------------------------------------------------------------------
' USER32
'--------------------------------------------------------------------------------------------------
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (ByRef _
    TLPINITCOMMONCONTROLSEX As InitCommonControlsEx) As Long
    
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As _
    Long
    
Private Declare Function MoveWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal _
    X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal _
    bRepaint As Long) As Long
    
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, _
    lpPoint As POINTAPI) As Long

Private Declare Function GetParent Lib "user32.dll" (ByVal hwnd As Long) As Long

Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal _
    hdc As Long) As Long

'USER32 ANSI
Private Declare Function CreateWindowEx Lib "user32.dll" Alias _
    "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal _
    lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal _
    hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
    
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" _
    (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) _
    As Long

'USER32 UNICODE
Private Declare Function CreateWindowExW Lib "user32" (ByVal dwExStyle As Long, _
    ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As _
    Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As _
    Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, _
    lpParam As Any) As Long
    
Private Declare Function SendMessageW Lib "user32" (ByVal hwnd As Long, ByVal _
    wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long

'--------------------------------------------------------------------------------------------------
' GDI32
'--------------------------------------------------------------------------------------------------
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As _
    Long
    
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal _
    nIndex As Long) As Long

'GDI32 ANSI
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As _
    Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal _
    i As Long, ByVal u As Long, ByVal s As Long, ByVal C As Long, ByVal OP As Long, _
    ByVal cp As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long

'GDI32 UNICODE
Private Declare Function CreateFontW Lib "gdi32" (ByVal H As Long, ByVal W As _
    Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal _
    u As Long, ByVal s As Long, ByVal C As Long, ByVal OP As Long, ByVal cp As Long, _
    ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long

'--------------------------------------------------------------------------------------------------
' KERNEL32
'--------------------------------------------------------------------------------------------------
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As _
    Any, pSrc As Any, ByVal ByteLen As Long)
    
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal _
    nNumerator As Long, ByVal nDenominator As Long) As Long

'--------------------------------------------------------------------------------------------------
' Variablen
'--------------------------------------------------------------------------------------------------
'Handles
Private m_hWnd As Long
Private m_hFont As Long

Private m_objFont As StdFont
Private m_lngSelectedItem As Long
Private WithEvents cSubClassing As clsHook
Attribute cSubClassing.VB_VarHelpID = -1

'--------------------------------------------------------------------------------------------------
' Events
'--------------------------------------------------------------------------------------------------
Public Event TabClick(ByVal mIndex As Long)
Public Event Paint(ByVal mTab As Long)
Public Event ForwardMsg(uMsg As WM_CONST, wParam As Long, lParam As Long, lngReturnValue As Long)

Private Sub Class_Initialize()
    Dim InitCC As InitCommonControlsEx
    InitCC.dwICC = &H8
    InitCC.dwSize = Len(InitCC)
    Call InitCommonControlsEx(InitCC)
    Set m_objFont = New StdFont
    Set cSubClassing = New clsHook
End Sub

'-----------------------------------------------------------
' PUBLIC SUB: Create
'
' Erstellt ein neues TabStrip Control
'-----------------------------------------------------------
Public Sub Create(lngParent As Long, X As Long, Y As Long, Width As Long, Height As Long)
    If (IsUnicodeSupported) Then
        m_hWnd = CreateWindowExW(0, StrConv("SysTabControl32", vbUnicode), 0, &H40000000 Or &H10000000, X, Y, Width, Height, lngParent, 1, App.hInstance, ByVal 0)
    Else
        m_hWnd = CreateWindowEx(0, "SysTabControl32", 0, &H40000000 Or &H10000000, X, Y, Width, Height, lngParent, 1, App.hInstance, ByVal 0)
    End If
    Call SendMessage(m_hWnd, CCM_SETUNICODEFORMAT, Abs(CLng(IsUnicodeSupported)), 0)
    cSubClassing.CreateHook lngParent
    Call cSubClassing.AddMessage(WM_PAINT)
    Call cSubClassing.AddMessage(WM_NOTIFY)
    Call cSubClassing.AddMessage(WM_CTLCOLORSTATIC)
End Sub

'-----------------------------------------------------------
' PUBLIC SUB: AddTab
'
' Fgt einen neuen Tab hinzu
'-----------------------------------------------------------
Public Sub AddTab(Text As String, Optional Index As Long = -1, Optional hIcon As Long = 0)
    Dim Item As TCITEM
    Item.iImage = -1
    Item.mask = &H1 Or &H2
    Item.iImage = hIcon
    If (Index = -1) Then Index = Tabs
    If (IsUnicodeSupported) Then
        Item.pszText = StrConv(Text, vbUnicode)
        Call SendMessageW(m_hWnd, TCM_INSERTITEMW, Index, Item)
    Else
        Item.pszText = Text
        Call SendMessage(m_hWnd, TCM_INSERTITEMA, Index, Item)
    End If
End Sub

'-----------------------------------------------------------
' PROPERTY GET: Tabs
'
' Gibt die Anzahl der Tabs zurck
'-----------------------------------------------------------
Public Property Get Tabs() As Long
    If (IsUnicodeSupported) Then
        Tabs = SendMessageW(m_hWnd, TCM_GETITEMCOUNT, 0, 0)
    Else
        Tabs = SendMessage(m_hWnd, TCM_GETITEMCOUNT, 0, 0)
    End If
End Property

'-----------------------------------------------------------
' PROPERTY SET: Font
'
' Legt die Schrift fr das TabStrip fest
'-----------------------------------------------------------
Public Property Set Font(newVal As StdFont)
    Dim lhDC As Long
    Set m_objFont = newVal
    lhDC = GetDC(GetActiveWindow)
    If (m_hFont <> 0) Then
        DeleteObject m_hFont
    End If
    If (IsUnicodeSupported) Then
        m_hFont = CreateFontW(-MulDiv(m_objFont.Size, GetDeviceCaps(lhDC, LOGPIXELSY), 72), 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, StrConv(m_objFont.Name & Chr$(0), vbUnicode))
        Call SendMessageW(m_hWnd, WM_SETFONT, m_hFont, ByVal 1)
    Else
        m_hFont = CreateFont(-MulDiv(m_objFont.Size, GetDeviceCaps(lhDC, LOGPIXELSY), 72), 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, m_objFont.Name & Chr$(0))
        Call SendMessage(m_hWnd, WM_SETFONT, m_hFont, ByVal 1)
    End If
    Call ReleaseDC(m_hWnd, lhDC)
End Property

'-----------------------------------------------------------
' PROPERTY GET: Font
'
' Gibt die verwendete Schrift zurck
'-----------------------------------------------------------
Public Property Get Font() As StdFont
    Set Font = m_objFont
End Property

Private Sub Class_Terminate()
    Set cSubClassing = Nothing
    If (m_hFont <> 0) Then
        DeleteObject m_hFont
    End If
    If (m_hWnd <> 0) Then
        Call DestroyWindow(m_hWnd)
    End If
End Sub

Public Sub Move(Optional lngLeft As Long = -1, Optional lngTop As Long = -1, Optional lngWidth As Long = -1, Optional lngHeight As Long = -1)
    Dim udtWindowRect As RECT
    Call GetWindowRect(m_hWnd, udtWindowRect)
    With udtWindowRect
        If (lngLeft = -1) Then
            lngLeft = .Left
        Else
            lngLeft = (lngLeft / m_lngTwipsPerPixelX)
        End If
        If (lngTop = -1) Then
            lngTop = .Top
        Else
            lngTop = (lngTop / m_lngTwipsPerPixelY)
        End If
        If (lngWidth = -1) Then
            lngWidth = (.Right - .Left)
        Else
            lngWidth = lngWidth / m_lngTwipsPerPixelX
        End If
        If (lngHeight = -1) Then
            lngHeight = (.Bottom - .Top)
        Else
            lngHeight = lngHeight / m_lngTwipsPerPixelY
        End If
    End With
    Call MoveWindow(m_hWnd, lngLeft, lngTop, lngWidth, lngHeight, 1)
End Sub

Private Sub cSubClassing_Before(uMsg As WM_CONST, wParam As Long, lParam As Long, lngReturnValue As Long)
    Dim udtNotify As NMHDR
    Select Case uMsg
        Case WM_NOTIFY
            CopyMemory udtNotify, ByVal lParam, LenB(udtNotify)
            If (udtNotify.Code = TCN_SELCHANGE) Then
                m_lngSelectedItem = SendMessage(m_hWnd, TCM_GETCURSEL, 0, 0)
                RaiseEvent TabClick(m_lngSelectedItem)
                lngReturnValue = 1
            End If
        Case WM_PAINT
            RaiseEvent Paint(m_lngSelectedItem)
        Case Else
            RaiseEvent ForwardMsg(uMsg, wParam, lParam, lngReturnValue)
    End Select
End Sub

'-----------------------------------------------------------
' PROPERTY GET: Height
'
' Gibt die Hhe der TabStrip zurck
'-----------------------------------------------------------
Public Property Get Height() As Long
    Dim udtWindowRect As RECT
    Call GetWindowRect(m_hWnd, udtWindowRect)
    Height = (udtWindowRect.Bottom - udtWindowRect.Top) * m_lngTwipsPerPixelY
End Property

'-----------------------------------------------------------
' PROPERTY GET: Width
'
' Gibt die Breite der TabStrip zurck
'-----------------------------------------------------------
Public Property Get Width() As Long
    Dim udtWindowRect As RECT
    Call GetWindowRect(m_hWnd, udtWindowRect)
    Width = (udtWindowRect.Right - udtWindowRect.Left) * m_lngTwipsPerPixelX
End Property

'-----------------------------------------------------------
' PROPERTY GET: Left
'
' Gibt den Abstand zum linken Rand des Parent-Windows zurck
'-----------------------------------------------------------
'FIXIT: 'Left' Funktion durch 'Left$' Funktion ersetzen                                    FixIT90210ae-R9757-R1B8ZE
Public Property Get Left() As Single
    Dim udtWindowRect As RECT, _
        udtWindowPos As POINTAPI
    Call GetWindowRect(m_hWnd, udtWindowRect)
    udtWindowPos.X = udtWindowRect.Left
    udtWindowPos.Y = udtWindowRect.Top
    Call ScreenToClient(GetParent(m_hWnd), udtWindowPos)
    Left = (udtWindowPos.X * m_lngTwipsPerPixelX)
End Property

'-----------------------------------------------------------
' PROPERTY GET: Top
'
' Gibt die y Position der TabStrip zurck
'-----------------------------------------------------------
Public Property Get Top() As Long
    Dim udtWindowRect As RECT, _
        udtWindowPos As POINTAPI
    Call GetWindowRect(m_hWnd, udtWindowRect)
    udtWindowPos.X = udtWindowRect.Left
    udtWindowPos.Y = udtWindowRect.Top
    Call ScreenToClient(GetParent(m_hWnd), udtWindowPos)
    Top = (udtWindowPos.Y * m_lngTwipsPerPixelY)
End Property

'-----------------------------------------------------------
' PROPERTY LET: Top
'
' Legt die Y Position der TabStrip fest
'-----------------------------------------------------------
Public Property Let Top(lngTop As Long)
    Dim udtWindowRect As RECT, _
        lngLeft As Long, _
        lngWidth As Long, _
        lngHeight As Long
    Call GetWindowRect(m_hWnd, udtWindowRect)
    With udtWindowRect
        lngLeft = .Left
        lngHeight = (.Bottom - .Top)
        lngWidth = (.Right - .Left)
    End With
    lngTop = (lngTop / m_lngTwipsPerPixelY)
    Call MoveWindow(m_hWnd, lngLeft, lngTop, lngWidth, lngHeight, 1)
End Property

'-----------------------------------------------------------
' PROPERTY LET: Width
'
' Legt die Breite der TabStrip fest
'-----------------------------------------------------------
Public Property Let Width(lngWidth As Long)
    Dim udtWindowRect As RECT, _
        lngLeft As Long, _
        lngTop As Long, _
        lngHeight As Long
    Call GetWindowRect(m_hWnd, udtWindowRect)
    With udtWindowRect
        lngLeft = .Left
        lngTop = .Top
        lngHeight = (.Bottom - .Top)
    End With
    lngWidth = (lngWidth / m_lngTwipsPerPixelX)
    Call MoveWindow(m_hWnd, lngLeft, lngTop, lngWidth, lngHeight, 1)
End Property

'-----------------------------------------------------------
' PROPERTY LET: Height
'
' Legt die Hhe der TabStrip fest
'-----------------------------------------------------------
Public Property Let Height(lngHeight As Long)
    Dim udtWindowRect As RECT, _
        lngLeft As Long, _
        lngTop As Long, _
        lngWidth As Long
    Call GetWindowRect(m_hWnd, udtWindowRect)
    With udtWindowRect
        lngLeft = .Left
        lngTop = .Top
        lngWidth = (.Right - .Left)
    End With
    lngHeight = (lngHeight / m_lngTwipsPerPixelY)
    Call MoveWindow(m_hWnd, lngLeft, lngTop, lngWidth, lngHeight, 1)
End Property

'-----------------------------------------------------------
' PROPERTY GET: hWnd
'
' Gibt das Handle des TabStrips zurck
'-----------------------------------------------------------
Public Property Get hwnd() As Long
    hwnd = m_hWnd
End Property
