VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTextFormatting"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'**********************************************************
'*  Klasse zur Formatierung von Texten
'*
'*  Erstellt von Bjrn Tschrtner (bat_ware@surfeu.de)
'*  Letzte nderung: 20.04.2004
'*  Version: 1.3
'**********************************************************

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long

Private Const EM_CHARFROMPOS& = &HD7
Private LinkWords() As String

Private Const WM_PASTE = &H302

Private Type POINTAPI
   X As Long
   Y As Long
End Type

Private Type LinkList
   llHref As String
   llPos As Long
   llEndPos As Long
End Type

Private LinkList() As LinkList

Dim m_SelLink As String

Private WordSeperators() As String
Private TextWordSeperators() As String
Private strWordSeperators As String

Dim m_TagStartChar As String
Dim m_TagEndChar As String

Public Property Let TagStartChar(Value As String)
   m_TagStartChar = Value
End Property
Public Property Get TagStartChar() As String
   TagStartChar = m_TagStartChar
End Property

Public Property Let TagEndChar(Value As String)
   m_TagEndChar = Value
End Property
Public Property Get TagEndChar() As String
   TagEndChar = m_TagEndChar
End Property

'-----------------------------

Public Property Get SelLink() As String
   SelLink = m_SelLink
End Property

Private Sub Class_Initialize()
   Call SetWordSeperators
   m_TagStartChar = "["
   m_TagEndChar = "]"
   
End Sub

Private Sub SetWordSeperators()
   Dim I As Long
   
   LinkWords = Split("http:// https:// ftp:// www. www2. mailto: callto: about: \\", " ")
   WordSeperators = Split("(-)- -" & Chr(34) & "-" & Chr(10) & "-" & Chr(13) & "-" & vbTab, "-")
   TextWordSeperators = Split("(-)- -!-.-,-:-;-[-]-<->-|-?-'-" & Chr$(34) & "-" & Chr$(13) & "-" & Chr$(10) & "-" & vbTab, "-")

   strWordSeperators = ""
   For I = 0 To UBound(WordSeperators)
      strWordSeperators = strWordSeperators & WordSeperators(I)
   Next I

End Sub

Public Sub SetSmilies(TextObject As RichTextBox, picSmiles As PictureBox, picClipboard As PictureBox, Optional Start As Long = 1)
   On Local Error GoTo ErrorHandler
   Dim I As Long
   Dim SmileyIndex As Long
   Dim lenText As Long
   Dim SmileyStart As Long, SmileyStartTest As Long
   Dim SmileyKey As Long, curKey As String
   
   Start = Start - 1
   If Start <= 0 Then Start = 1
   lenText = Len(TextObject.Text)
   
   For SmileyIndex = 0 To UBound(modChat.Smilies)
   
      For I = 0 To lenText
         
         'search smiley'
         SmileyStart = 0
         For SmileyKey = 0 To UBound(modChat.Smilies(SmileyIndex).sdKey)
            If modChat.Smilies(SmileyIndex).sdKey(SmileyKey) <> "" Then
               SmileyStartTest = InStr(I + 1, TextObject.Text, modChat.Smilies(SmileyIndex).sdKey(SmileyKey), vbTextCompare)
               If (SmileyStart = 0 And SmileyStartTest > 0) Or (SmileyStartTest < SmileyStart And SmileyStartTest > 0) Then
                  SmileyStart = SmileyStartTest
                  curKey = modChat.Smilies(SmileyIndex).sdKey(SmileyKey)
               End If
            End If
         Next SmileyKey
         
         If SmileyStart > 0 Then
            
            TextObject.SelStart = SmileyStart - 1
            TextObject.SelLength = Len(curKey)
         
            If FileExists(modChat.Smilies(SmileyIndex).sdFilename) Then
               'insert picture'
               picSmiles.BackColor = TextObject.BackColor
               picSmiles.Cls
               picSmiles.Picture = LoadPicture(modChat.Smilies(SmileyIndex).sdFilename)
               picClipboard.Picture = Clipboard.GetData()
               Clipboard.Clear
               Clipboard.SetData picSmiles.Image
               TextObject.Locked = False
               Call SendMessage(TextObject.hwnd, WM_PASTE, 0, 0)
               TextObject.Locked = True
               Clipboard.Clear
               Clipboard.SetData picClipboard.Picture
               picClipboard.Picture = LoadPicture("")
            End If
         
         Else
            Exit For
         End If
   
      Next I
   
   Next SmileyIndex

   Exit Sub
   
ErrorHandler:
   'NOP'

End Sub

Public Sub TagHighLight(TextObject As RichTextBox, Optional Start As Long = 1)
   On Local Error GoTo ErrorHandler
   Dim I As Long
   Dim lenText As Long
   Dim TagStart As Long, TagEnd As Long, EndTagStart As Long, ParameterSplit As Long
   Dim TagName As String, TagParameters As String, TagEndString As String
   
   Dim tmpParameterValue As String
   
   Dim TestPos As Long
   Dim FlagStripTag As Boolean
   
   If Start = 0 Then Start = 1
   lenText = Len(TextObject.Text)
   
   For I = Start To lenText
      TagStart = InStr(I, TextObject.Text, m_TagStartChar)
   
      If TagStart > 0 Then
         TagEnd = InStr(TagStart, TextObject.Text, m_TagEndChar)
         If TagEnd = 0 Then TagEnd = lenText
      
         TagName = Mid$(TextObject.Text, TagStart + 1, TagEnd - TagStart - 1)
         
         'split parameters'
         ParameterSplit = InStr(1, TagName, " ")
         If ParameterSplit Then
            TagParameters = Mid$(TagName, ParameterSplit + 1)
            TagName = Mid$(TagName, 1, ParameterSplit - 1)
         Else
            TagParameters = ""
         End If
         
         I = TagEnd
         
         TagEndString = m_TagStartChar & "/" & TagName & m_TagEndChar
         EndTagStart = InStr(TagEnd, TextObject.Text, TagEndString, vbTextCompare)
         
         If EndTagStart > 0 Then
      
            'select text'
            TextObject.SelStart = TagEnd
            TextObject.SelLength = EndTagStart - TagEnd - 1
            
            FlagStripTag = True
            
            Select Case UCase$(TagName)
               
               Case "B"
                  'bold'
                  TextObject.SelBold = True
            
               Case "I"
                  'italic'
                  TextObject.SelItalic = True
            
               Case "U"
                  'underline'
                  TextObject.SelUnderline = True
                       
               Case "LINK"
                  'hyper link'
                  tmpParameterValue = GetParameterValue(TagParameters, "url")
                  
                  'create new hyper link'
                  If Not CBool(Not (Not (LinkList))) Then
                     ReDim LinkList(0)
                  Else
                     ReDim Preserve LinkList(UBound(LinkList) + 1)
                  End If
                  
                  'set link parameters'
                  LinkList(UBound(LinkList)).llHref = tmpParameterValue
                  LinkList(UBound(LinkList)).llPos = TagStart
                  LinkList(UBound(LinkList)).llEndPos = TagStart + (EndTagStart - TagEnd - 1) - 2
                  
                  TextObject.SelUnderline = True
                  TextObject.SelColor = colMessageLink
                  
               Case Else ' Added by KonRad on 09/07/2004 '
                  ' nothing '
                  FlagStripTag = False
            End Select
            
            If FlagStripTag Then
               'remove tags'
               TextObject.SelStart = EndTagStart - 1
               TextObject.SelLength = Len(TagEndString)
               TextObject.SelText = ""
               lenText = lenText - Len(TagEndString)
               
               TextObject.SelStart = TagStart - 1
               TextObject.SelLength = TagEnd - TagStart + 1
               TextObject.SelText = ""
               lenText = lenText - (TagEnd - TagStart + 1)
            End If
      
         End If
      
      Else
         Exit For
      
      End If
   
   Next I
   
   ' Code hinzugefgt von KonRad am 09/07/2004 '
    If CBool(modSettings.GetSetting("MessageWindow", "MsgStyleNG")) Then
        For I = Start To lenText
            TagStart = InStr(I, TextObject.Text, "/")
            
            If TagStart > 0 Then
                TagEnd = InStr(TagStart + 1, TextObject.Text, "/")
                
                If TagEnd > 0 Then
                    TextObject.SelStart = TagStart
                    TextObject.SelLength = TagEnd - TagStart - 1
                    TextObject.SelItalic = True
                    I = TagEnd + 1
                End If
            End If
        Next I
        
        For I = Start To lenText
            TagStart = InStr(I, TextObject.Text, "*")
            
            If TagStart > 0 Then
                TagEnd = InStr(TagStart + 1, TextObject.Text, "*")
                
                If TagEnd > 0 Then
                    TextObject.SelStart = TagStart - 1
                    TextObject.SelLength = TagEnd - TagStart + 1
                    TextObject.SelBold = True
                    I = TagEnd + 1
                End If
            End If
        Next I
        
        For I = Start To lenText
            TagStart = InStr(I, TextObject.Text, "_")
            
            If TagStart > 0 Then
                TagEnd = InStr(TagStart + 1, TextObject.Text, "_")
                
                If TagEnd > 0 Then
                    TextObject.SelStart = TagStart - 1
                    TextObject.SelLength = TagEnd - TagStart + 1
                    TextObject.SelUnderline = True
                    I = TagEnd + 1
                End If
            End If
        Next I
    End If
   ' / Code hinzugefgt von KonRad am 09/07/2004 '
   
   Exit Sub

ErrorHandler:
   'NOP'

End Sub

Public Sub LinkHighLight(TextObject As RichTextBox, SearchStart As Long, SearchEnd As Long)
   Dim curPos As Long
   Dim StartPos As Long, EndPos As Long
   Dim I As Long, i2 As Long
   Dim memSelStart As Long, memSelLength As Long
   Dim lenText As Long
   Dim posTest As Long
   
   memSelStart = TextObject.SelStart
   memSelLength = TextObject.SelLength
   lenText = Len(TextObject.Text)

   For curPos = SearchStart To SearchEnd

      StartPos = 0
      For I = 0 To UBound(LinkWords)
         For i2 = 0 To UBound(WordSeperators)
            posTest = InStr(curPos, TextObject.Text, WordSeperators(i2) & LinkWords(I), vbTextCompare)
            If (StartPos <= 0 And posTest > 0) Or (posTest > 0 And posTest < StartPos) Then StartPos = posTest
         Next i2
      Next I

      If StartPos > 0 Then
         StartPos = StartPos + 0
         EndPos = lenText
         For I = 0 To UBound(WordSeperators)
            posTest = InStr(StartPos + 1, TextObject.Text, WordSeperators(I), vbTextCompare)
            If (EndPos <= 0 And posTest > 0) Or (posTest > 0 And posTest < EndPos) Then EndPos = posTest
         Next I

         TextObject.SelStart = StartPos
         TextObject.SelLength = EndPos - StartPos
         TextObject.SelColor = colMessageLink
         TextObject.SelUnderline = True

         curPos = EndPos + 1

      Else
         Exit For

      End If

   Next curPos

   TextObject.SelStart = memSelStart
   TextObject.SelLength = memSelLength

End Sub

Public Function IsLinkHover(TextObject As RichTextBox, ByVal X As Long, ByVal Y As Long) As Boolean
   Dim curText As String
   Dim curPos As Long
   Dim I As Long
      
   curPos = GetMouseTextPos(TextObject, X, Y)
   curText = GetWord(TextObject, X, Y)
   
   If IsWordUrl(curText) Then
      IsLinkHover = True
      m_SelLink = curText
   Else
      If CBool(Not (Not (LinkList))) Then
         For I = UBound(LinkList) To 0 Step -1
            If curPos >= LinkList(I).llPos And curPos <= LinkList(I).llEndPos Then
               IsLinkHover = True
               m_SelLink = LinkList(I).llHref
               Exit For
            End If
         Next I
      Else
         IsLinkHover = False
      End If
   End If

End Function

Private Function IsWordUrl(Text As String) As Boolean
   Dim I As Long
   
   IsWordUrl = False
   
   For I = 0 To UBound(LinkWords)
      If InStr(1, Text, LinkWords(I), vbTextCompare) = 1 Then
         IsWordUrl = True
         Exit For
      End If
   Next I
   
End Function

Private Function GetWord(TextObject As RichTextBox, ByVal X&, ByVal Y&) As String
   On Local Error Resume Next
   Dim pos&, P1&, P2&
   Dim curChar As String
   Dim MousePointer As POINTAPI
   
   MousePointer.X = X \ m_lngTwipsPerPixelX
   MousePointer.Y = Y \ m_lngTwipsPerPixelY
   pos = SendMessage(TextObject.hwnd, EM_CHARFROMPOS, 0&, MousePointer)
   If pos <= 0 Then Exit Function
   
   For P1 = pos + 1 To 1 Step -1
      curChar = Mid$(TextObject.Text, P1, 1)
      If InStr(1, strWordSeperators, curChar) > 0 Or Asc(curChar) < 32 Then Exit For
   Next P1
   P1 = P1 + 1
   
   For P2 = pos To Len(TextObject.Text)
      curChar = Mid$(TextObject.Text, P2, 1)
      If InStr(1, strWordSeperators, curChar) > 0 Or Asc(curChar) < 32 Then Exit For
   Next P2
   P2 = P2 - 1
   
   If P1 < P2 Then GetWord = Mid$(TextObject.Text, P1, P2 - P1 + 1)

End Function

Private Function GetMouseTextPos(TextObject As RichTextBox, ByVal X&, ByVal Y&) As Long
   On Local Error Resume Next
   Dim pos&, P1&, P2&
   Dim MousePointer As POINTAPI
   
   MousePointer.X = X \ m_lngTwipsPerPixelX
   MousePointer.Y = Y \ m_lngTwipsPerPixelY
   pos = SendMessage(TextObject.hwnd, EM_CHARFROMPOS, 0&, MousePointer)
   GetMouseTextPos = pos

End Function

Private Function GetParameterValue(ParameterList As String, ParameterName As String, Optional DefaultValue As String = "") As String
   Dim NameStart As Long
   Dim ValueStart As Long
   Dim ValueEnd As Long

   NameStart = InStr(1, ParameterList, ParameterName & "=", vbTextCompare)
   
   If NameStart > 0 Then
      ValueStart = NameStart + Len(ParameterName) + 2
      ValueEnd = InStr(ValueStart + 1, ParameterList & " ", " ")
      If ValueEnd = 0 Then ValueEnd = Len(ParameterList)
      GetParameterValue = Mid$(ParameterList, ValueStart - 1, ValueEnd - ValueStart + 1)
   Else
      GetParameterValue = DefaultValue
   End If

   If Left$(GetParameterValue, 1) = Chr$(34) Then GetParameterValue = Right$(GetParameterValue, Len(GetParameterValue) - 1)
   If Right$(GetParameterValue, 1) = Chr$(34) Then GetParameterValue = Left$(GetParameterValue, Len(GetParameterValue) - 1)

End Function

Public Sub GetWordCompletion(ByVal Text As String, ByVal SearchWord As String, ByVal CursorPos As Long, ByRef WordList() As String, ByRef WordStart As Long, ByRef WordEnd As Long)
   Dim curPos As Long
   Dim curWord As String
   Dim StartPos As Long, EndPos As Long
   Dim I As Long
   Dim lenText As Long
   Dim posTest As Long
   
   Text = " " & Text & " "
   SearchWord = SearchWord & " "
'   Text = Replace(Text, Chr$(13), " "): Text = Replace(Text, Chr$(10), " ")
   ReDim WordList(0)
   
   If CursorPos = 0 Then Exit Sub
   
   'get search word'
   StartPos = 0
   EndPos = CursorPos
   For I = 0 To UBound(TextWordSeperators)
      posTest = InStrRev(SearchWord, TextWordSeperators(I), EndPos, vbTextCompare)
      If posTest > 0 And posTest > StartPos Then StartPos = posTest
   Next I
'   If StartPos = EndPos Then StartPos = 0
   SearchWord = Mid$(SearchWord, StartPos + 1, EndPos - StartPos)
   WordStart = StartPos '- 1
   WordEnd = EndPos '- 1
   
'   SearchWord = Replace(SearchWord, Chr$(13), ""): SearchWord = Replace(SearchWord, Chr$(10), "")
   If SearchWord = "" Then Exit Sub
   
   lenText = Len(Text)

   For curPos = 1 To lenText

      'search start position'
      StartPos = 0
      For I = 0 To UBound(TextWordSeperators)
         posTest = InStr(curPos, Text, TextWordSeperators(I) & SearchWord, vbTextCompare)
         If (posTest > 0 And StartPos = 0) Or (posTest > 0 And posTest < StartPos) Then StartPos = posTest
      Next I

      If StartPos > 0 Then
         
         'search end position'
         EndPos = StartPos
         For I = 0 To UBound(TextWordSeperators)
            posTest = InStr(StartPos + 1, Text, TextWordSeperators(I), vbTextCompare)
            If (posTest > 0 And EndPos = StartPos) Or (posTest > 0 And posTest < EndPos) Then EndPos = posTest
         Next I
         
         'get word'
         If StartPos < EndPos Then
            curWord = Mid$(Text, StartPos + 1, EndPos - StartPos - 1)
            curPos = EndPos - 1
         Else
            curPos = EndPos
         End If

         'search word'
         For I = 1 To UBound(WordList)
            If UCase$(WordList(I)) = UCase$(curWord) Then curWord = ""
         Next I

         'add word'
         If curWord <> "" Then
            ReDim Preserve WordList(UBound(WordList) + 1)
            WordList(UBound(WordList)) = curWord
         End If

      Else
         Exit For
         
      End If

   Next curPos

End Sub

Public Function GetSelWordStart(ByVal Text As String, ByVal CursorPos As Long) As Long
   Dim StartPos As Long, EndPos As Long
   Dim I As Long
   Dim posTest As Long
   
   Text = Text & " "
   If CursorPos = 0 Then Exit Function

   'get selected word start position'
   StartPos = 0
   EndPos = CursorPos
   For I = 0 To UBound(TextWordSeperators)
      posTest = InStrRev(Text, TextWordSeperators(I), EndPos, vbTextCompare)
      If posTest > 0 And posTest > StartPos Then StartPos = posTest
   Next I
   
   GetSelWordStart = StartPos

End Function
