VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cInet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'################################################################################
' Modul        : cInet
' Beschreibung : Microsoft Internet Transfer Control Replacement
'
' Erstellt von : Christoph von Wittich
' Erstellt am  : Mittwoch, 14.05.2003
'
' Copyright (C) 2003 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Christoph@ActiveVB.de

Option Explicit

Private Const INTERNET_OPEN_TYPE_PRECONFIG As Long = 0
Private Const INTERNET_OPEN_TYPE_DIRECT As Long = 1
Private Const INTERNET_OPEN_TYPE_PROXY As Long = 3
Private Const INTERNET_FLAG_EXISTING_CONNECT = &H20000000
Private Const INTERNET_INVALID_PORT_NUMBER = 0
Private Const INTERNET_SERVICE_FTP = 1
Private Const INTERNET_FLAG_PRAGMA_NOCACHE As Long = &H100

Private Const FTP_TRANSFER_TYPE_BINARY = &H0

Private Const ICU_DECODE As Long = &H10000000

Private Const GENERIC_READ As Long = &H80000000


Public Enum icDataTypes
    icString = 0
    icByteArray = 1
End Enum

Public Enum icAccessTypes
    icDirect = INTERNET_OPEN_TYPE_DIRECT
    icNamedProxy = INTERNET_OPEN_TYPE_PROXY
    icUseDefault = INTERNET_OPEN_TYPE_PRECONFIG
End Enum

Public Enum icProtocols
    icUnknown = 0
    icDefault = 1
    icFTP = 2
    icReserved = 3
    icHTTP = 4
    icHTTPS = 5
End Enum

Private Type URL_COMPONENTS
    dwStructSize As Long
    lpszScheme As String
    dwSchemeLength As Long
    nScheme As Long
    lpszHostName As String
    dwHostNameLength As Long
    nPort As Long
    lpszUserName As String
    dwUserNameLength As Long
    lpszPassword As String
    dwPasswordLength As Long
    lpszUrlPath As String
    dwUrlPathLength As Long
    lpszExtraInfo As String
    dwExtraInfoLength As Long
End Type

Private Declare Sub InternetCanonicalizeUrl Lib "wininet.dll" Alias "InternetCanonicalizeUrlA" (ByVal lpszUrl As String, ByVal lpszBuffer As String, ByRef lpdwBufferLength As Long, ByVal dwFlags As Long)
Private Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" (ByVal hInternet As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByRef dwContext As Long) As Long
Private Declare Function InternetQueryDataAvailable Lib "wininet.dll" (ByVal hFile As Long, ByRef lpdwNumberOfBytesAvailable As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Boolean
Private Declare Function InternetReadFile Lib "wininet.dll" (ByVal hFile As Long, lpBuffer As Byte, ByVal dwNumberOfBytesToRead As Long, ByRef lpdwNumberOfBytesRead As Long) As Integer
Private Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInternet As Long) As Integer
Private Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal lpszAgent As String, ByVal dwAccessType As Long, ByVal lpszProxy As String, ByVal lpszProxyBypass As String, ByVal dwFlags As Long) As Long
Private Declare Function InternetGetLastResponseInfo Lib "wininet.dll" Alias "InternetGetLastResponseInfoA" (lpdwError As Long, ByVal lpszBuffer As String, lpdwBufferLength As Long) As Long
Private Declare Function InternetCrackUrl Lib "wininet.dll" Alias "InternetCrackUrlA" (ByVal lpszUrl As String, ByVal dwUrlLength As Long, ByVal dwFlags As Long, ByRef lpUrlComponents As URL_COMPONENTS) As Boolean
Private Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" (ByVal hInternetSession As Long, ByVal sServerName As String, ByVal nServerPort As Integer, ByVal sUsername As String, ByVal sPassword As String, ByVal lService As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long
Private Declare Function FtpOpenFile Lib "wininet.dll" Alias "FtpOpenFileA" (ByVal hFTPSession As Long, ByVal sBuff As String, ByVal Access As Long, ByVal Flags As Long, ByVal Context As Long) As Long

Private hInternetSession As Long
Private hFTPSession As Long
Private lResponseCode As Long
Private sResponseInfo As String
Private bBusy As Boolean
Private eProtocol As icProtocols
Private sRemoteHost As String
Private sURL As String
Private bCancel As Boolean
Private hRemoteFile As Long

Public AccessType As icAccessTypes
Public Proxy As String
Public UserName As String
Public Password As String
Public Tag As String
Public RemotePort As Long

Public Event StateChanged(ByVal State As Integer)

'-----------------------------------------------------------
' FUNCTION: OpenURL
'
' Gibt den Inhalt der angebenen URL zurck
'-----------------------------------------------------------
Public Function OpenURL(sURL As String, DataType As icDataTypes) As Variant
    Dim hRemoteFile As Long
    Dim Result As Long, mBuffer As String
    Dim mRead As Long
    Dim lpBuffer As Long
    Dim m_ByteArray() As Byte
    Dim mToCopy As Long
    bBusy = True
    If sURL <> "" Then URL = sURL
    If Connect Then
        lpBuffer = Len(URL)
        If InStr(URL, "://") < 1 Then URL = GetProtocolStr & URL
        InternetCanonicalizeUrl URL, URL, lpBuffer, 0
        URL = Left$(URL, lpBuffer)
        hRemoteFile = InternetOpenUrl(hInternetSession, URL, vbNullString, 0, INTERNET_FLAG_EXISTING_CONNECT Or INTERNET_FLAG_PRAGMA_NOCACHE, 0)
        InternetQueryDataAvailable hRemoteFile, mToCopy, 0, 0
        If mToCopy = 0 Then bBusy = False: Exit Function
        Do
            ReDim m_ByteArray(mToCopy - 1)
            Result = InternetReadFile(hRemoteFile, m_ByteArray(0), mToCopy, mRead)
            mBuffer = mBuffer & StrConv(m_ByteArray, vbUnicode)
            InternetQueryDataAvailable hRemoteFile, mToCopy, 0, 0
        Loop Until mToCopy = 0 Or bCancel
        InternetCloseHandle hRemoteFile
        Disconnect
        If DataType = icString Then
            OpenURL = mBuffer
        Else
            m_ByteArray = StrConv(mBuffer, vbFromUnicode)
            OpenURL = m_ByteArray
        End If
    End If
    bBusy = False
End Function

'-----------------------------------------------------------
' SUB: Connect
'
' Baut eine Verbindung zum Internet auf
'-----------------------------------------------------------
Private Function Connect() As Boolean
    bCancel = False
    hInternetSession = InternetOpen(App.EXEName, AccessType, Proxy, vbNullString, 0)
    If (hInternetSession = 0) Then Exit Function
    Connect = True
    If Protocol = icFTP Then
        hFTPSession = InternetConnect(hInternetSession, RemoteHost, RemotePort, UserName, Password, INTERNET_SERVICE_FTP, 0, 0)
        If hFTPSession = 0 Then Connect = False
    End If
End Function

'-----------------------------------------------------------
' SUB: Disconnect
'
' Trennt die Verbindung
'-----------------------------------------------------------
Private Sub Disconnect()
    InternetCloseHandle hFTPSession
    InternetCloseHandle hInternetSession
End Sub

'-----------------------------------------------------------
' PROPERTY GET: hInternet
'
' Gibt das Handle der aktuellen Verbindung zurck
'-----------------------------------------------------------
Public Property Get hInternet() As Long
    hInternet = hInternetSession
End Property

'-----------------------------------------------------------
' PROPERTY GET: Object
'
' Gibt die eigene Instanz zurck
'-----------------------------------------------------------
Public Property Get Object() As Object
    Set Object = Me
End Property

Private Sub Class_Initialize()
    AccessType = icDirect
    Protocol = icHTTP
    Proxy = vbNullString
End Sub

Private Function GetProtocolStr() As String
        Select Case Protocol
            Case icFTP
                GetProtocolStr = "ftp://"
            Case icHTTP
                GetProtocolStr = "http://"
            Case icHTTPS
                GetProtocolStr = "https://"
            Case icDefault
                GetProtocolStr = "http://"
        End Select
End Function

Private Sub GetStatus()
    Dim l As Long
    InternetGetLastResponseInfo lResponseCode, vbNullString, l
    If CBool(lResponseCode) Then
        sResponseInfo = String$(l + 1, 0)
        InternetGetLastResponseInfo lResponseCode, sResponseInfo, l
    End If
End Sub

'-----------------------------------------------------------
' PROPERTY GET: ResponseInfo
'
' Gibt die ResponseInfo der letzten Aktion zurck
'-----------------------------------------------------------
Public Property Get ResponseInfo() As String
    GetStatus
    ResponseInfo = sResponseInfo
End Property

'-----------------------------------------------------------
' PROPERTY GET: ResponseCode
'
' Gibt den ResponseCode der letzten Aktion zurck
'-----------------------------------------------------------
Public Property Get ResponseCode() As Long
    GetStatus
    ResponseCode = lResponseCode
End Property

'-----------------------------------------------------------
' PROPERTY GET: StillExecuting
'
' Gibt True zurck, wenn das Control beschftigt ist
'-----------------------------------------------------------
Public Property Get StillExecuting() As Boolean
    StillExecuting = bBusy
End Property

'-----------------------------------------------------------
' PROPERTY LET: Protocol
'
' Legt das zu verwendene Protokoll fest
'-----------------------------------------------------------
Public Property Let Protocol(mProtocol As icProtocols)
    eProtocol = mProtocol
    Select Case eProtocol
        Case icHTTP
            RemotePort = 80
        Case icFTP
            RemotePort = 21
        Case icUnknown
            RemotePort = INTERNET_INVALID_PORT_NUMBER
    End Select
End Property

'-----------------------------------------------------------
' PROPERTY GET: Protocol
'
' Gibt das verwendete Protokoll zurck
'-----------------------------------------------------------
Public Property Get Protocol() As icProtocols
    Protocol = eProtocol
End Property

'-----------------------------------------------------------
' PROPERTY GET: RemoteHost
'
' Gibt den aktuellen RemoteHost zurck
'-----------------------------------------------------------
Property Get RemoteHost() As String
    RemoteHost = sRemoteHost
End Property

'-----------------------------------------------------------
' PROPERTY LET: RemoteHost
'
' Legt den RemoteHost fest
'-----------------------------------------------------------
Property Let RemoteHost(mRemoteHost As String)
    Dim uC As URL_COMPONENTS
    sRemoteHost = mRemoteHost
    uC.lpszHostName = Space$(255)
    uC.dwHostNameLength = 255
    uC.dwStructSize = LenB(uC)
    InternetCrackUrl URL, 0, ICU_DECODE, uC
    If Trim$(uC.lpszHostName) <> sRemoteHost Then
        URL = sRemoteHost
    End If
End Property

'-----------------------------------------------------------
' PROPERTY GET: URL
'
' Gibt die aktuelle URL zurck
'-----------------------------------------------------------
Property Get URL() As String
    URL = sURL
End Property

'-----------------------------------------------------------
' PROPERTY LET: URL
'
' Legt die URL fest
'-----------------------------------------------------------
Property Let URL(mUrl As String)
    Dim uC As URL_COMPONENTS
    Dim tURL As String
    Password = "": UserName = ""
    sURL = mUrl
    tURL = sURL
    If InStr(tURL, "://") < 1 Then tURL = GetProtocolStr & tURL
    uC.lpszHostName = Space$(255)
    uC.dwHostNameLength = 255
    uC.dwStructSize = LenB(uC)
    InternetCrackUrl tURL, 0, ICU_DECODE, uC
    If Trim$(uC.lpszHostName) <> sRemoteHost Then
        sRemoteHost = Trim$(uC.lpszHostName)
    End If
End Property

Public Sub Cancel()
    Disconnect
    bCancel = True
End Sub

'Public Function GetChunk(Size As Long, DataType As icDataTypes) As Variant
'    Dim Result As Long
'    Dim mRead As Long
'    Dim m_ByteArray() As Byte
'    If Size = 0 Then Exit Function
'    ReDim m_ByteArray(Size)
'    Result = InternetReadFile(hRemoteFile, m_ByteArray(0), Size, mRead)
'    If DataType = icString Then
'        GetChunk = StrConv(m_ByteArray, vbUnicode)
'    Else
'        GetChunk = m_ByteArray
'    End If
'End Function
'
'Public Sub Execute(Optional mUrl As String, Optional Operation As String, Optional Data As String, Optional requestHeaders As String)
'    Dim strRemoteFile As String
'    Select Case LCase$(Operation)
'        Case "get"
'            Select Case Protocol
'                Case icHTTP
'                    hRemoteFile = InternetOpenUrl(hInternetSession, URL, vbNullString, 0, INTERNET_FLAG_EXISTING_CONNECT, 0)
'                Case icFTP
'                    hRemoteFile = FtpOpenFile(hFTPSession, strRemoteFile, GENERIC_READ, FTP_TRANSFER_TYPE_BINARY, 0)
'            End Select
'    End Select
'End Sub
