VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSocketWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'*****************************************************************************************************************
'*
'*  Klasse fr den AVBM um ein Socketwindow zu erstellen um dieses subclassen zu knnen
'*  2004 (c) Kai Liebenau
'*
'*****************************************************************************************************************
Option Explicit

Public Event SocketQuery(lngSocket As Long, lngEventID As Long, lngError As Long)

Public Enum SubClassRet
    NotWindow = 0
    SubClassBusy = -1
    WindowSubclassed = 1
End Enum

'Private Const FD_CONNECT As Long = &H10&

Private lnghWnd         As Long         'Fensterhandle
'Private lnguMsg         As Long
'Private lngwParam       As Long
'Private lnglParam       As Long
Private lngOldWndProc   As Long         'Originale WndProc
Private lnghTimer       As Long         'Timerhandle
Private bolOwner        As Boolean      'True wenn das Fenster von der Klasse erstellt wurde
Dim c_colMsgFilter      As Collection   'Collection mit dem Messagefilter

Private cStack          As clsStack     'Nachrichtenstack
Implements iSocketSubClass              'Interface fr die neue WndProc und TimerProc

Private Sub Class_Terminate()
Call KillTimerForBuffer(lnghTimer)           'Timer lschen
Call Sleep(10)                               '10ms warten
Call UnSetSubClass(lnghWnd)                  'Fenster unsubclassen
Call Sleep(10)                               '10ms warten
If bolOwner Then Call DestroyWindow(lnghWnd) 'Fenster zerstren
Call Sleep(10)                               '10ms warten
Set c_colMsgFilter = Nothing                 'Messagefilter lschen
Set cStack = Nothing                         'Stack lschen
Call Sleep(10)                               '10ms warten
End Sub

Private Property Let iSocketSubClass_OldWndProc(ByVal RHS As Long)
lngOldWndProc = RHS 'Original WndProc merken
End Property

Private Sub iSocketSubClass_TimerProc(ByVal i_hWnd As Long, ByVal i_uMsg As Long, ByVal i_idEvent As Long, ByVal i_dwTime As Long)
On Local Error GoTo ErrorHandler
Dim lngwParam  As Long
Static bolBusy As Boolean
If bolBusy Then Exit Sub 'Wenn schon ein Timer in der Sub hngt, dann raus hier
bolBusy = True 'Sub als belegt kennzeichnen
If cStack.Popsize > 0 Then 'Sind Nachrichten im Stack
    Do
        lngwParam = cStack.Peek_wParam 'SocketID aus dem Stack schffeln
        'Wir drfen sie nicht aus dem Stack enternen, da bei einem nicht verarbeitetn Event
        'die Stackreihenfolge durcheinander bringen wrde
        RaiseEvent SocketQuery(lngwParam, GetLoWord(cStack.Peek_lParam), GetHiWord(cStack.Peek_lParam))
        
        If lngwParam <> 0 Then 'wurde der Event verarbeitet ???
            Exit Do 'Wenn nein, dann Sub Verlassen
        Else
            'Wenn ja, dann Nachricht aus dem Stack lschen
            cStack.RemoveFirstMsg
        End If
    Loop Until cStack.Popsize = 0 'solange wiederholen bis der Stack leer ist
End If
'Debug.Print "Beat"
ErrorHandler:
'Wenn ein Fehler aufgetreten ist, dann sie Sub wieder Freigeben
'Im Normalfall, luft die Sub hier auch durch
bolBusy = False
End Sub

Private Function iSocketSubClass_WndMsg(ByVal i_hWnd As Long, ByVal i_uMsg As Long, ByVal i_wParam As Long, ByVal i_lParam As Long) As Long
On Local Error GoTo WndProcErrorHandler
Dim lngNetEvent As Long
Dim lngNetError As Long

'Wenn wir nicht die Addresse der orginalen WndProc haben, dann wech damit
If lngOldWndProc = 0 Then iSocketSubClass_WndMsg = -1: Exit Function

If i_uMsg = GetMsgFilter(i_uMsg) Then 'soll gefiltert werden?
    lngNetEvent = GetLoWord(i_lParam)
    lngNetError = GetHiWord(i_lParam)
    If lngNetEvent = FD_CONNECT Or lngNetEvent = FD_CLOSE Or lngNetError <> 0 Then
        RaiseEvent SocketQuery(i_wParam, lngNetEvent, lngNetError)
        If i_wParam <> 0 Then cStack.Push i_uMsg, i_wParam, i_lParam
    Else
        cStack.Push i_uMsg, i_wParam, i_lParam 'ab auf den Stack
    End If
    iSocketSubClass_WndMsg = 1
    Exit Function
End If
'Nachricht zur originalen WndProc weiterleiten
iSocketSubClass_WndMsg = CallWindowProc(lngOldWndProc, i_hWnd, i_uMsg, i_wParam, i_lParam)

Exit Function
WndProcErrorHandler:
'Fehlerbehandlung
Debug.Print Err.Description
'Wenn ein Fehler oben aufgetreten ist, dann Nachricht weiter zur Originalen WndProc
iSocketSubClass_WndMsg = CallWindowProc(lngOldWndProc, i_hWnd, i_uMsg, i_wParam, i_lParam)
End Function

Private Function GetMsgFilter(uMsg As Long) As Long
On Local Error Resume Next
GetMsgFilter = c_colMsgFilter.Item("WM" & uMsg) 'Soll diese Message gefiltert werden?
End Function

Private Function GetHiWord(ByVal lnglParam As Long) As Long
lnglParam = lnglParam And &HFFFF0000 'Nur die oberen 16 Bit zulassen
If lnglParam Then lnglParam = lnglParam / &H10000 'diese 16 Bit nach unten rollen
GetHiWord = lnglParam
End Function
Private Function GetLoWord(ByVal lnglParam As Long) As Long
GetLoWord = lnglParam And &HFFFF& 'nur die unteren 16 Bit zurckgeben
End Function

Private Sub UnSubClassWindow()
Call UnSetSubClass(lnghWnd)  'Fenster unsubclassen
lnghWnd = 0                  'Fensterhandle lschen
lngOldWndProc = 0            'Alte WndProc lschen
Set c_colMsgFilter = Nothing 'Messagefilter lschen
Set cStack = Nothing         'Stack lschen
End Sub

Private Function SubClassWindow(ByVal hwnd As Long) As SubClassRet
'prfen ob es schon ein Fenster gibt
If lnghWnd = 0 Then
    'Fensterhandle in die Klassenvariable bertragen
    lnghWnd = hwnd
    'Messagefilter und Stack initialisieren
    If c_colMsgFilter Is Nothing Then Set c_colMsgFilter = New Collection
    If cStack Is Nothing Then Set cStack = New clsStack
    'Fenster subclassen
    SubClassWindow = SetSubClass(hwnd, Me)
    If SubClassWindow = SubClassBusy Then
        'das Fenster wurde schon von einer Klasse subgeclassed
        'Messagefilter und Stack auflsen
        Set c_colMsgFilter = Nothing
        Set cStack = Nothing
        'Fensterhandle zurcksetzen
        lnghWnd = 0
    End If
Else
    'Diese Klasse hat schon ein Fenster subgeclassed
    SubClassWindow = SubClassBusy
End If
End Function

'*************************************************************************************************************
'* eigenes Window erstellen und Hooken
'*************************************************************************************************************

Public Function CreateWindowAndHook() As Long
Dim p_lnghWnd As Long
'prfen ob es schon ein Fenster gibt
If lnghWnd = 0 Then
    'Fenster erstellen
    p_lnghWnd = CreateWindowEx(0&, "STATIC", "SOCKET_WINDOW_AVBM", 0&, 0&, 0&, 0&, 0&, 0&, 0&, App.hInstance, ByVal 0&)
    'Fenster Hooken
    If SubClassWindow(p_lnghWnd) <> 1 Then
        'Fenster konnte nicht gehookt werden, darum wieder zerstren
        Call DestroyWindow(p_lnghWnd)
        lnghWnd = 0 'Klassenvariable zurcksetzen
        Debug.Print "Not Window"
    Else
        bolOwner = True 'Fenster erstellt und gehookt
        CreateWindowAndHook = p_lnghWnd
        lnghTimer = SetTimerForBuffer(Me) 'Timer erstellen und Interface bekanntgeben
    End If
End If
End Function
Public Function DestroyAndUnhook() As Long
If lnghWnd <> 0 Then Class_Terminate
End Function

'*************************************************************************************************************
'*Propertys
'*************************************************************************************************************

Property Let AddMSGFilter(newMSGFilter As Long)
On Error Resume Next
'Prfen od der Messagefilter schon existiert
If c_colMsgFilter Is Nothing Then Set c_colMsgFilter = New Collection
'Message adden
c_colMsgFilter.Add newMSGFilter, "WM" & newMSGFilter
End Property
Property Let DelMSGFilter(newMSGFilter As Long)
On Error Resume Next
'Message deleten, keine Prfung auf Bestand der Collection ntig
c_colMsgFilter.Remove "WM" & newMSGFilter
End Property
